import { TableProps } from 'antd/lib/table/interface';
import { SearchBarOpts, VTableColumn, KeyWord } from '../Table/interface';
export interface ApiTableProps extends TableProps<any> {
    /**
     * 说明：
     * ApiTable 并不支持 CRUD, 如果需要，自行实现
     * 选择模式：传入此参数，会增加选择项 checkbox
    */
    onSelectedChange?: (keys?: string[], objects?: any[]) => void;
    /**
    * 模糊匹配
   */
    keyword?: KeyWord;
    /**
     * 查询条件Panel
    */
    searchBar?: SearchBarOpts;
    /***
     * 搜索前转换查询参数
     */
    beforeSearch?: (param: any) => any;
    /**
      * 序号字段
      * 1. 不传（或者传false） ：不显示 “序号”
      * 2. 传 true 显示 “序号”
      * 3. 传指定标题 ：显示指定标题
      *
      */
    showIndex?: boolean | string;
    /**
     * 字段扩展，支持 transate 翻译
     */
    columns: VTableColumn[];
    /**
     * 查询接口
    */
    query: string;
    /**
     * 默认查询参数
    */
    default?: any;
    /**
     * 是否加载，默认为 true
    */
    autoLoad?: boolean;
    /**
     * 每页记录数量
    */
    pageSize?: number;
    /**
     * 是否显示SizeChanger
     */
    showSizeChanger?: boolean;
    /**
     * 是否有totalAcc字段,是否使用totalAcc字段作为总数展示
     */
    hasTotalAcc?: boolean;
    /**
     * 最多查询多少条数据
     */
    maxCount?: number;
    /**
     * 查询的回调
     */
    onQuery?: (list: any, total: any, totalAcc: any) => any;
}
