"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseModal2 = exports.BaseModal = void 0;
var React = require("react");
/**
 * 说明 BaseModal 是一个没有任何功能的组件，并不是一个Model。
 *
 * 但它有一些好处，特别适用于开发 Model的时候进行继承以达到简化代码的目的：
 *
 * 1.  `BaseModal` 约束了 `props` 参数，必须传入 `show:boolean`
 * 2. 可选参数可传入 `isEdit:boolean` `data:any` `dispatch:any` ，用于一般的弹框参数约束
 * 3. 可以传入任何扩展参数，自行设定（不会报TypeScript编译问题）
 * 4. 提供 `_isReShow(old)` 方法，判断每次触发 `render` 时，是不是重新打开
*/
var BaseModal = /** @class */ (function (_super) {
    __extends(BaseModal, _super);
    function BaseModal() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    BaseModal.prototype._isReShow = function (old) {
        if (old.show === false && this.props.show === true) {
            return true;
        }
        return false;
    };
    BaseModal.prototype._isShutDown = function (old) {
        if (old.show === true && this.props.show === false) {
            return true;
        }
        return false;
    };
    return BaseModal;
}(React.PureComponent));
exports.BaseModal = BaseModal;
/**
 * 说明：原 BaseModal 不再使用，使用 BaseModal2
*/
var BaseModal2 = /** @class */ (function (_super) {
    __extends(BaseModal2, _super);
    function BaseModal2() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    BaseModal2.prototype._isReShow = function (old) {
        if (old.visible === false && this.props.visible === true) {
            return true;
        }
        return false;
    };
    BaseModal2.prototype._isShutDown = function (old) {
        if (old.visible === true && this.props.visible === false) {
            return true;
        }
        return false;
    };
    return BaseModal2;
}(React.PureComponent));
exports.BaseModal2 = BaseModal2;
