import { TableProps } from 'antd/lib/table/interface';
import { SearchBarOpts, VTableColumn } from '../Table/interface';
export interface ESTableProps extends TableProps<any> {
    /**
     * 查询条件Panel
    */
    searchBar?: SearchBarOpts;
    /**
     * 查询接口, 默认为/api-audit-es/search
     * '/api-search/search/content/search'
     * '/api-audit-es/search'
    */
    query?: string;
    /**
      * 序号字段
      * 1. 不传（或者传false） ：不显示 “序号”
      * 2. 传 true 显示 “序号”
      * 3. 传指定标题 ：显示指定标题
      *
      */
    showIndex?: boolean | string;
    /**
     * 字段扩展
     */
    columns: VTableColumn[];
    /**
     * 默认参数
     * 默认为模糊查询, 需要精确查询时, 字段前加_,如 {_a: '1'},
     */
    default?: {
        and?: object;
        or?: object;
        not?: object;
    };
    /**
     * 是否加载，默认为 true
    */
    autoLoad?: boolean;
    /**
     * 每页记录数量
    */
    pageSize?: number;
    /**
      * 索引名称,多个索引用逗号隔开
      */
    indexName: string;
    /**
     * 索引时间,默认为'event_time'
     */
    timeField?: string;
    /**
     * 索引日志类型，默认为'logs'
     */
    typeName?: string;
    /**
     * 开始时间，格式为'YYYY-MM-DD HH:mm:ss'
     */
    startTime: string;
    /**
     * 结束时间，格式为'YYYY-MM-DD HH:mm:ss'
     */
    endTime: string;
    needQuery?: boolean;
}
