"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MODE = void 0;
var antd_1 = require("antd");
var _ = require("lodash");
var moment = require("moment");
var React = require("react");
var utils_1 = require("../../utils");
var Linked_1 = require("./Linked");
var SearchBar_1 = require("../Table/SearchBar");
var UPagination_1 = require("../UPagination");
var ACTION = function (props) { return React.createElement("span", { className: "table-act", onClick: function (evt) { evt.stopPropagation(); props.onClick(); }, title: "".concat(props.name || '') },
    props.icon && React.createElement(antd_1.Icon, { type: props.icon }),
    React.createElement("span", null, props.title)); };
var EDIT = function (props) { return React.createElement("span", { className: "table-act-edit", onClick: function (evt) { evt.stopPropagation(); props.onClick(); }, title: "\u7F16\u8F91 ".concat(props.name || '') },
    React.createElement(antd_1.Icon, { type: 'edit' }),
    React.createElement("span", null, _.has(props, 'title') ? props.title : '编辑')); };
var DELETE = function (props) { return React.createElement(antd_1.Popconfirm, { onConfirm: function () { return props.onClick(); }, title: React.createElement("span", { className: "table-delete-tip" },
        "\u786E\u5B9A\u8981\u5220\u9664",
        React.createElement("b", null, props.name),
        "\u5417?") },
    React.createElement("span", { className: "table-act-delete", title: "\u5220\u9664 ".concat(props.name || '') },
        React.createElement(antd_1.Icon, { type: 'delete' }),
        React.createElement("span", null, _.has(props, 'title') ? props.title : '删除'))); };
/**
 * @private
*/
var MODE;
(function (MODE) {
    MODE[MODE["ADD"] = 0] = "ADD";
    MODE[MODE["EDIT"] = 1] = "EDIT";
    MODE[MODE["COMMON"] = 2] = "COMMON";
})(MODE = exports.MODE || (exports.MODE = {}));
/**
 * 列表弹框，弹出一个列表。
 * 1. 可以对列表里面的数据进行增删改查
 * 2. 可以弹出一个单选或多选框，选一条或多条数据后，返回给页面
*/
var ListModal = /** @class */ (function (_super) {
    __extends(ListModal, _super);
    function ListModal() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.rowKey = 'id';
        _this.mode = MODE.COMMON;
        _this.linked = null;
        _this.state = {
            list: [],
            current: 1,
            loading: true,
            total: 0,
            columns: [],
            selectedRowKeys: [],
            selectedRowObjects: [],
        };
        _this.sorter = {};
        _this.param = {};
        _this.editObject = {};
        // 过滤
        _this.query = function (param) {
            var _a;
            var _b = window.VAP_GLOBAL, VLIST = _b.VLIST, SIZE_DEFAULT = _b.PAGINATION.SIZE_DEFAULT;
            _this.param = _.assign({}, _this.props.param, (_a = {}, _a[window.VAP_GLOBAL.VLIST.start] = 0, _a[window.VAP_GLOBAL.VLIST.count] = SIZE_DEFAULT, _a), param);
            _this.setState({ loading: true });
            utils_1.Ajax.POST(_this.props.query, _this.param, function (json) {
                var _a;
                _this.mode = MODE.COMMON;
                _this.setState((_a = { loading: false, list: _.has(json, [VLIST.list]) ? json[VLIST.list] : json.data }, _a[VLIST.total] = json.total, _a.current = 1, _a));
            });
        };
        return _this;
    }
    //删除的传参
    ListModal.prototype.componentWillMount = function () {
        this.rowKey = this.props.rowKey || this.rowKey;
    };
    //数据初始化 - 渲染之前的更新
    ListModal.prototype.componentDidUpdate = function (old) {
        var _a;
        var _this = this;
        var _b = window.VAP_GLOBAL, VLIST = _b.VLIST, SIZE_DEFAULT = _b.PAGINATION.SIZE_DEFAULT;
        if (!old.show && this.props.show) {
            this.linked = new Linked_1.default(this.props.columns);
            this.mode = MODE.COMMON;
            this.editObject = {};
            this.param = _.assign({}, (_a = {}, _a[VLIST.start] = 0, _a[VLIST.count] = SIZE_DEFAULT, _a), this.props.param);
            utils_1.Ajax.POST(this.props.query, this.param, function (json) {
                _this.setState({
                    loading: false,
                    list: _.has(json, "list") ? json.list : json.data,
                    current: 1,
                    total: json.total,
                    columns: _this.buildOption()
                });
            });
        }
        else if (old.show === true && this.props.show === false) {
            this.mode = MODE.COMMON;
            this.editObject = {};
            this.setState({
                loading: false,
                list: [],
                current: 1,
                total: 0,
                selectedRowKeys: [],
                selectedRowObjects: [],
            });
        }
    };
    //添加数据 - 执行
    ListModal.prototype.doAdd = function (record, save) {
        var _this = this;
        var RESULT = window.VAP_GLOBAL.RESULT;
        var list = _.concat([], this.state.list);
        var total = this.state.total;
        if (save) {
            utils_1.Ajax.PUT(this.props.add, _.assign({}, this.editObject, { _add: null, _edit: null }), function (json) {
                if (json[RESULT.code] == RESULT.success) {
                    antd_1.message.success('添加成功');
                    _this.editObject = {};
                    _this.mode = MODE.COMMON;
                    if (_.has(json, 'data')) {
                        list[0] = _.assign(list[0], _this.props.param, json.data, { _edit: false });
                        _this.setState({ list: list, total: total + 1 });
                    }
                    else {
                        utils_1.Ajax.POST(_this.props.query, _this.param, function (json) {
                            _this.setState({ list: _.has(json, "list") ? json.list : json.data, total: json.total });
                        });
                    }
                }
                else {
                    antd_1.message.error('添加失败');
                }
            });
        }
        else {
            list.shift();
            this.setState({ list: list });
            this.mode = MODE.COMMON;
        }
    };
    //编辑数据 - 执行
    ListModal.prototype.doEdit = function (record, save) {
        var _this = this;
        var RESULT = window.VAP_GLOBAL.RESULT;
        var list = _.concat([], this.state.list);
        if (save) {
            utils_1.Ajax.PATCH(this.props.edit, _.assign({}, this.editObject, { _add: null, _edit: null }), function (json) {
                if (json[RESULT.code] == RESULT.success) {
                    antd_1.message.success('修改成功');
                    var obj = json.data ? json.data : _this.editObject;
                    _this.setState({ list: utils_1.Model.update(_this.state.list, _.assign({}, obj, { _edit: false }), _this.rowKey) });
                    _this.editObject = {};
                    _this.mode = MODE.COMMON;
                }
                else {
                    antd_1.message.error('修改失败');
                }
            });
        }
        else {
            list.map(function (item) { return item._edit = false; });
            this.setState({ list: list });
            this.mode = MODE.COMMON;
        }
    };
    //table - 操作栏 - 点击
    ListModal.prototype.exitEditMode = function (record, save) {
        if (save) {
            for (var i = 0; i < this.props.columns.length; i++) {
                var field = this.props.columns[i];
                var txt = this.editObject[field.dataIndex];
                if (field.require) {
                    if (_.isEmpty(_.toString(txt))) {
                        antd_1.message.error("".concat(field.title, " \u4E0D\u80FD\u4E3A\u7A7A"));
                        return;
                    }
                }
                if (field.pattern) {
                    if (field.require || !_.isEmpty(txt)) {
                        if (_.isFunction(field.pattern)) {
                            if (!field.pattern(txt)) {
                                antd_1.message.error(field.message || "".concat(field.title, " \u683C\u5F0F\u9519\u8BEF"));
                                return;
                            }
                        }
                        else if (_.isString(field.pattern)) {
                            if (!RegExp(field.pattern).test(txt)) {
                                antd_1.message.error(field.message || "".concat(field.title, " \u683C\u5F0F\u9519\u8BEF"));
                                return;
                            }
                        }
                        else if (!field.pattern.test(txt)) {
                            antd_1.message.error(field.message || "".concat(field.title, " \u683C\u5F0F\u9519\u8BEF"));
                            return;
                        }
                    }
                }
            }
        }
        switch (this.mode) {
            case MODE.ADD:
                this.doAdd(record, save);
                break;
            case MODE.EDIT:
                this.doEdit(record, save);
                break;
            default:
                break;
        }
    };
    //modal标题 - 添加 - 点击
    ListModal.prototype.add = function () {
        if (this.mode === MODE.COMMON) {
            this.mode = MODE.ADD;
            this.linked.init(null);
            var list = _.concat([], this.state.list);
            var obj_1 = _.assign({ _edit: true, _add: true, }, this.props.param);
            this.props.columns.map(function (column) {
                if (_.isArray(column.options) && column.options.length) {
                    obj_1[column.dataIndex] = column.options[0].value;
                }
                else if (column.type == 'timerange') {
                    obj_1[column.dataIndex] = '09:00:00-18:00:00';
                }
            });
            this.editObject = _.assign({}, obj_1);
            list.unshift(_.assign({}, obj_1));
            this.setState({ list: list });
        }
    };
    //table - 操作栏 - 编辑 - 点击
    ListModal.prototype.edit = function (record) {
        var _this = this;
        if (this.mode === MODE.COMMON) {
            this.mode = MODE.EDIT;
            this.linked.init(record);
            this.editObject = _.assign({}, this.props.param, record);
            var list = _.concat([], this.state.list);
            list.map(function (item) {
                if (item[_this.rowKey] == record[_this.rowKey]) {
                    item._edit = true;
                }
                else {
                    item._edit = false;
                }
            });
            this.setState({ list: list });
        }
    };
    //过滤数据中出现null的情况
    ListModal.prototype.renderColumns = function (text, record, column, render) {
        var _this = this;
        if (column.readonly && this.mode == MODE.EDIT) {
            var _text = text;
            if (render) {
                _text = render(text, record);
            }
            if (column.options) {
                var val = _.find(column.options, { value: text + '' });
                _text = val ? val.name : text;
            }
            return React.createElement("span", { title: _text }, _text);
        }
        // if (column.readonly && this.mode == MODE.ADD) {
        //     return ''
        // }
        if (record && record._edit) {
            if (column.options) {
                if (column.type == 'switch') {
                    var checked = !(text == (column.options[1].value + ''));
                    if ((!text || _.isNil(text)) && _.has(column, 'conf.defaultChecked')) {
                        checked = _.get(column, 'conf.defaultChecked');
                    }
                    return React.createElement(antd_1.Switch, __assign({}, (column.conf || {}), { onChange: function (val) { return _this.editObject[column.dataIndex] = (val ? column.options[0].value : column.options[1].value); }, size: "small", checkedChildren: column.options[0].name, unCheckedChildren: column.options[1].name, defaultChecked: checked }));
                }
                else {
                    return React.createElement(antd_1.Select, __assign({}, (column.conf || {}), { style: { width: column.width }, onChange: function (val) {
                            _this.editObject[column.dataIndex] = val;
                            if (column.link) {
                                _this.linked.call(column, val, function () {
                                    _this.setState({ __now: _.now() });
                                });
                            }
                        }, size: "small", defaultValue: text }), this.linked.getOptions(column).map(function (item) { return React.createElement(antd_1.Select.Option, { value: item.value }, item.name); }));
                }
            }
            if (column.type == 'number') {
                // return <InputNumber size="default"  defaultValue={text} onChange={val => this.editObject[column.dataIndex] = val} />;
                var param = {};
                return React.createElement(antd_1.InputNumber, __assign({}, (column.conf || {}), { size: "small", style: { padding: 0, height: 22, width: column.width }, defaultValue: text, onChange: function (val) { return _this.editObject[column.dataIndex] = val; } }));
            }
            if (column.type == 'timerange') {
                var times = text ? text.split('-') : ['09:00:00', '18:00:00'];
                var format = 'HH:mm:ss';
                return React.createElement("div", null,
                    React.createElement(antd_1.TimePicker, __assign({}, (column.conf || {}), { defaultValue: moment(times[0], format), size: "small", format: format, onChange: function (time, val) { return _this.editObject[column.dataIndex] = val + '-' + _this.editObject[column.dataIndex].split('-')[1]; } })),
                    React.createElement(antd_1.TimePicker, __assign({}, (column.conf || {}), { defaultValue: moment(times[1], format), size: "small", format: format, onChange: function (time, val) { return _this.editObject[column.dataIndex] = _this.editObject[column.dataIndex].split('-')[0] + '-' + val; } })));
            }
            if (column.type == 'date') {
                var defaultValue = text ? moment(text) : moment();
                this.editObject[column.dataIndex] = defaultValue.format('YYYY-MM-DD HH:mm:ss');
                return React.createElement(antd_1.DatePicker, __assign({}, (column.conf || {}), { defaultValue: defaultValue, size: "small", onChange: function (date) { return _this.editObject[column.dataIndex] = date.format('YYYY-MM-DD HH:mm:ss'); } }));
            }
            if (column.type == 'datetime') {
                var defaultValue = text ? moment(text) : moment();
                this.editObject[column.dataIndex] = defaultValue.format('YYYY-MM-DD HH:mm:ss');
                return React.createElement(antd_1.DatePicker, __assign({ showTime: true }, (column.conf || {}), { defaultValue: defaultValue, size: "small", onChange: function (date) { return _this.editObject[column.dataIndex] = date.format('YYYY-MM-DD HH:mm:ss'); } }));
            }
            if (column.type == 'DATA') {
                var defaultValue = text ? moment(text) : moment();
                this.editObject[column.dataIndex] = defaultValue.format('YYYY-MM-DD');
                return React.createElement(antd_1.DatePicker, __assign({}, (column.conf || {}), { defaultValue: defaultValue, size: "small", onChange: function (date) { return _this.editObject[column.dataIndex] = date.format('YYYY-MM-DD'); } }));
            }
            return React.createElement(antd_1.Input, __assign({}, (column.conf || {}), { size: "small", style: { padding: 0, height: 22 }, defaultValue: text, onChange: function (e) { return _this.editObject[column.dataIndex] = e.target.value; } }));
        }
        if (render) {
            return render(text, record);
        }
        if (column.options) {
            var val = _.find(column.options, { value: text + '' });
            return val ? val.name : text;
        }
        return React.createElement("span", { title: text }, text);
    };
    //删除数据 - 执行
    ListModal.prototype.doDel = function (record) {
        var _this = this;
        var _a = window.VAP_GLOBAL, RESULT = _a.RESULT, SIZE_DEFAULT = _a.PAGINATION.SIZE_DEFAULT;
        var param = {};
        var total = this.state.total;
        if (_.has(this.props, 'delKey')) {
            param[this.props.delKey] = record[this.rowKey];
        }
        else {
            param.ids = record[this.rowKey];
        }
        _.assign(param, this.props.param);
        utils_1.Ajax.DELETE(this.props.del, param, function (json) {
            if (json[RESULT.code] == RESULT.success) {
                antd_1.message.success('删除成功');
                var list = utils_1.Model.del(_this.state.list, [record[_this.rowKey]], _this.rowKey);
                var total_1 = _this.state.total - 1;
                if (list.length == 0 || ((_this.state.current * SIZE_DEFAULT - total_1) > SIZE_DEFAULT)) {
                    _this.search({ current: 1, pageSize: SIZE_DEFAULT }, null, _this.sorter);
                }
                else {
                    _this.setState({ list: list, total: total_1 });
                }
            }
            else {
                antd_1.message.error('删除失败');
            }
        });
    };
    //编辑时 - 将column转化为input
    ListModal.prototype.buildEditColumn = function () {
        var _this = this;
        var columns = _.concat([], this.props.columns);
        columns.map(function (column) {
            var render = column.render;
            column.render = function (text, record) { return _this.renderColumns(text === undefined
                ? (_.has(column, 'conf.defaultValue') ? _.get(column, 'conf.defaultValue') : (_.isArray(column.options) && column.options.length) ? column.options[0].value + '' : '')
                : (text === null ? '' : (text + '')), record, column, render); };
        });
        return columns;
    };
    //列的构筑
    ListModal.prototype.buildOption = function () {
        var _this = this;
        var columns = this.buildEditColumn();
        var SIZE_DEFAULT = window.VAP_GLOBAL.PAGINATION.SIZE_DEFAULT;
        if (this.props.edit || this.props.del || this.props.select || this.props.add) {
            var operCol = {
                title: '操作',
                dataIndex: this.rowKey,
                className: 'table-actions',
                width: 120,
                render: function (text, editObject) {
                    var acts = [];
                    if (editObject._edit) {
                        acts.push(React.createElement(ACTION, { icon: "check", title: "\u4FDD\u5B58", onClick: function () { return _this.exitEditMode(editObject, true); } }));
                        acts.push(React.createElement(ACTION, { icon: "close", title: "\u53D6\u6D88", onClick: function () { return _this.exitEditMode(editObject, false); } }));
                    }
                    else if (_this.props.select) {
                        acts.push(React.createElement(antd_1.Button, { size: "small", onClick: function () { return _this.props.select([editObject]); } }, "\u9009\u62E9"));
                    }
                    else {
                        if (_this.props.edit) {
                            acts.push(React.createElement(EDIT, { name: "\u8FD9\u6761\u8BB0\u5F55", onClick: function () { return _this.edit(editObject); } }));
                        }
                        if (_this.props.del) {
                            acts.push(React.createElement(DELETE, { name: "\u8FD9\u6761\u8BB0\u5F55", onClick: function () { return _this.doDel(editObject); } }));
                            // acts.push(<Popconfirm title={`确认要删除这条记录吧 ?`} onConfirm={() => { this.doDel(editObject) }}>
                            //     <Icon type="close" title="删除" />
                            // </Popconfirm>)
                        }
                        if (_.isEmpty(acts) && _this.props.add) {
                            acts.push(React.createElement("i", { className: 'anticon' }));
                        }
                    }
                    if (_this.props.otherAction && _this.props.otherAction.length > 0) {
                        _this.props.otherAction.map(function (d) {
                            var _title = d.tip(editObject);
                            acts.push(React.createElement(antd_1.Icon, { type: d.icon, title: _title, onClick: function () {
                                    d.render(editObject).then(function (resp) {
                                        if (d.remove) {
                                            var param = {};
                                            if (_.has(_this.props, 'delKey')) {
                                                param[_this.props.delKey] = editObject[_this.rowKey];
                                            }
                                            else {
                                                param.ids = editObject[_this.rowKey];
                                            }
                                            _.assign(param, _this.props.param);
                                            var list = utils_1.Model.del(_this.state.list, [editObject[_this.rowKey]], _this.rowKey);
                                            var total = _this.state.total - 1;
                                            if (list.length == 0 || ((_this.state.current * SIZE_DEFAULT - total) > SIZE_DEFAULT)) {
                                                _this.search({ current: 1, pageSize: SIZE_DEFAULT }, null, _this.sorter);
                                            }
                                            else {
                                                _this.setState({ list: list, total: total });
                                            }
                                            _this.setState({ list: list });
                                        }
                                        d.callback(resp);
                                    });
                                } }));
                        });
                    }
                    return acts;
                }
            };
            columns.push(operCol);
        }
        return columns;
    };
    // 翻页与排序
    ListModal.prototype.search = function (pagination, filters, sorter) {
        var _this = this;
        if (this.props.showPage !== false && this.state.list.length > (_.get(this.param, window.VAP_GLOBAL.VLIST.count) || 0) && !pagination) {
            return;
        }
        var VLIST = window.VAP_GLOBAL.VLIST;
        var _param = {};
        var current = this.state.current;
        if (pagination) {
            current = pagination.current;
            _param[VLIST.start] = (current - 1) * pagination.pageSize;
            _param[VLIST.count] = pagination.pageSize;
        }
        else if (sorter) {
            if (!_.isEqual(this.sorter, sorter)) {
                _param.start = 0;
                this.sorter = sorter;
            }
            if (_.has(sorter, 'field')) {
                _param[VLIST.order] = sorter.field;
                _param[VLIST.by] = sorter.order == 'ascend' ? 'asc' : 'desc';
            }
            else {
                _param[VLIST.order] = null;
                _param[VLIST.by] = null;
            }
        }
        _.assign(this.param, _param);
        this.setState({ loading: true });
        utils_1.Ajax.POST(this.props.query, this.param, function (json) {
            _this.mode = MODE.COMMON;
            _this.setState({ loading: false, list: _.has(json, "list") ? json.list : json.data, total: json.total, current: current });
        });
    };
    ListModal.prototype.renderSearchBar = function () {
        var _this = this;
        var searchBar = null;
        if (_.has(this.props, 'searchBar')) {
            searchBar = this.props.searchBar;
        }
        else if (_.has(this.props, 'search')) {
            searchBar = { fields: this.props.search.map(function (item) { return ({ field: item.field, label: item.title }); }) };
        }
        if (searchBar) {
            return React.createElement(SearchBar_1.default, __assign({}, searchBar, { onSearch: function (param) { return _this.query(param); }, default: this.props.param, param: this.param }));
        }
        return React.createElement(React.Fragment, null);
    };
    ListModal.prototype.renderFooter = function () {
        var _this = this;
        var footer = [];
        var _a = window.VAP_GLOBAL, _b = _a.PAGINATION, SIZE_DEFAULT = _b.SIZE_DEFAULT, OPTIONS = _b.OPTIONS, VLIST = _a.VLIST;
        if (this.state.list.length <= (_.get(this.param, VLIST.count) || 0)) {
            if (this.props.showPage !== false && this.state.total > SIZE_DEFAULT) {
                footer.push(React.createElement(UPagination_1.default, { onChange: function (current, pageSize) { return _this.search({ current: current, pageSize: pageSize }, null); }, current: this.state.current, total: this.state.total, showSizeChanger: false, pageSize: SIZE_DEFAULT }));
            }
        }
        if (this.props.mutiSelect && this.props.select) {
            footer.push(React.createElement("div", null));
            footer.push(React.createElement(antd_1.Button, { disabled: this.state.selectedRowKeys.length == 0, onClick: function (e) { return _this.props.select(_this.state.selectedRowObjects); }, type: "primary" },
                "\u9009\u62E9",
                this.state.selectedRowKeys.length > 0 ? "(".concat(this.state.selectedRowKeys.length, ")") : ''));
        }
        else if (_.has(this.props, 'onOk')) {
            footer.push(React.createElement("div", null));
            footer.push(React.createElement(antd_1.Button, { size: "small", onClick: function (e) { return _this.props.onOk(null); }, type: "primary" }, "\u786E\u5B9A"));
        }
        if (footer.length) {
            return footer;
        }
        return null;
    };
    ListModal.prototype.render = function () {
        var _this = this;
        var title = [];
        if (_.has(this.props, 'add')) {
            title.push(React.createElement(antd_1.Button, { size: "small", style: { marginRight: 12 }, onClick: function (e) { return _this.add(); }, icon: "plus-circle" }, "\u6DFB\u52A0"));
        }
        if (this.props.title) {
            title.push(this.props.title);
        }
        var tableParam = {};
        if (this.props.mutiSelect && this.props.select) {
            tableParam.rowSelection = {
                selectedRowKeys: this.state.selectedRowKeys,
                onChange: function (selectedRowKeys, selectedRowObjects) {
                    _this.setState({ selectedRowKeys: selectedRowKeys, selectedRowObjects: selectedRowObjects });
                },
            };
        }
        var className = ['_list_modal', 'vap-table', 'vap-table-inner'];
        if (this.props.fixedCol) {
            className.push(' vap-table-fixcol');
        }
        if (this.props.className) {
            className.push(this.props.className);
        }
        return React.createElement(antd_1.Modal, { title: title.length ? title : null, visible: this.props.show, width: this.props.width || 880, onCancel: this.props.onCancel, bodyStyle: __assign({ padding: 0 }, this.props.bodyStyle), className: className.join(' '), footer: this.renderFooter(), zIndex: this.props.zIndex || undefined },
            this.renderSearchBar(),
            React.createElement(antd_1.Table, __assign({}, tableParam, { loading: this.state.loading, rowKey: this.rowKey, columns: this.state.columns, onChange: function (pagination, filters, sorter) { return _this.search(null, filters, sorter); }, dataSource: this.state.list, pagination: this.props.showPage !== false && (this.state.list.length > (_.get(this.param, window.VAP_GLOBAL.VLIST.count) || 0)) && {
                    showTotal: function () { return React.createElement("span", { className: "vap-table-pagination-info upagination-info" },
                        "\u5171 ",
                        React.createElement("b", { className: "high" }, _this.state.total),
                        " \u6761"); }
                }, size: "small" })));
    };
    return ListModal;
}(React.PureComponent));
exports.default = ListModal;
