import * as React from 'react';
interface LEDScreen {
    /**
     * 数据源
     */
    data: any[];
    /**
     * 渲染节点
     */
    itemRender: (item: any, index: number) => React.ReactNode;
    /**
    * 轮播速度 数值越小越快 quick快 slow慢
    */
    speed?: number | 'quick' | 'slow' | 'default';
    /**
     * 是否展示操作区 可控制速度、暂停播放
     */
    action?: boolean;
    /**
     * 类名
     */
    className?: string;
    /**
     * 样式
     */
    style?: React.CSSProperties;
}
export default class extends React.PureComponent<LEDScreen> {
    listScreen: any;
    setInterval: any;
    scrollTop: number;
    state: {
        speed: number;
        showAction: boolean;
        play: boolean;
    };
    load(): void;
    componentDidMount(): void;
    componentWillUnmount(): void;
    getSpeed(): number;
    onMouseOver(): void;
    onMouseLeave(): void;
    render(): JSX.Element;
}
export {};
