"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var _ = require("lodash");
var antd_1 = require("antd");
var utils_1 = require("../../utils");
var dva_1 = require("dva");
var SearchBar_1 = require("../Table/SearchBar");
var SelectBar_1 = require("../Table/SelectBar");
var SearchKeyWord_1 = require("../Table/SearchKeyWord");
var UPagination_1 = require("../UPagination");
var HighLight_1 = require("../../utils/HighLight");
var MIN_HEIGHT = 694;
/**
 * STable ： 数据Table组件
 * 相当于 VTable 的静态版本
 * STable 不支持REF方法
*/
var STable = /** @class */ (function (_super) {
    __extends(STable, _super);
    function STable(props) {
        var _this = _super.call(this, props) || this;
        _this.mode = 'common';
        _this.id = utils_1.PageUtil.genId();
        _this.rowKey = 'id';
        _this.param = {};
        _this.columns = [];
        _this.initColumns = []; //完整的columns，用于隐藏列恢复
        _this.state = {
            data: [],
            total: 0,
            pageSize: _.get(_this.props.pagination, 'defaultPageSize') || window.VAP_GLOBAL.PAGINATION.SIZE_DEFAULT,
            showCustom: false,
            selectedRowKeys: [],
            selectObjects: [],
            current: 1,
            maxHeight: MIN_HEIGHT,
            customTemp: {} //临时列，往columnCache读取或写入数据
        };
        /**
         * 查询
         *  */
        _this.query = function (param) {
            var _a;
            var VLIST = window.VAP_GLOBAL.VLIST;
            _.extend(_this.param, _this.props.default, param, (_a = {}, _a[VLIST.start] = 0, _a[VLIST.count] = _this.state.pageSize, _a));
            _.keys(_this.param).map(function (key) {
                if (_.isString(_this.param[key]) && _this.param[key] == '') {
                    _.unset(_this.param, key);
                }
            });
            _this.setState({ current: 1, selectedRowKeys: [], selectedRows: [], });
            _this.fetchData(_this.param);
        };
        if (_.has(_this.props, 'rowKey')) {
            _this.rowKey = _this.props.rowKey;
        }
        if (_.has(_this.props, 'keyword.highlight')) {
            //@ts-ignore
            var highlight = _this.props.keyword.highlight;
            var keys_1 = new Set();
            highlight.map(function (item) { return keys_1.add(item); });
            _this.props.columns.map(function (item) {
                if (keys_1.has(item.dataIndex) && (item.render == null || item.render == undefined)) {
                    item.render = function (text) {
                        return (0, HighLight_1.highLight)(text, _this.param.keyword_);
                    };
                }
            });
        }
        _this.columns = _.concat([], _.filter(_this.props.columns, function (item) { return item.show === undefined || item.show == true; }));
        _this.initColumns = _.concat([], _.filter(_this.props.columns, function (item) { return item.show === undefined || item.show == true; }));
        if (_.has(_this.props, 'mode')) {
            _this.mode = _this.props.mode;
        }
        if (_this.props.showIndex !== false) {
            if (_this.props.showIndex === undefined) {
                var _indexItem = {
                    // title: <span>序号</span>,
                    title: React.createElement("span", null, "\u5E8F\u53F7"),
                    className: '_index',
                    render: function (d, j, i) { return i + (_this.state.current - 1) * _this.state.pageSize + 1; }
                };
                _this.columns.unshift(_indexItem);
                _this.initColumns.unshift(_indexItem);
            }
            else if (_.isString(_this.props.showIndex)) {
                var _indexItem = {
                    // title: <span>{this.props.showIndex}</span>,
                    title: React.createElement("span", null, _this.props.showIndex),
                    className: '_index',
                    render: function (d, j, i) { return i + (_this.state.current - 1) * _this.state.pageSize + 1; }
                };
                _this.columns.unshift(_indexItem);
                _this.initColumns.unshift(_indexItem);
            }
        }
        return _this;
    }
    STable.prototype.fetchData = function (param) {
        var _this = this;
        var data = _.concat([], this.props.dataSource);
        if (data.length == 0) {
            this.setState({ data: data, total: 0 });
            return;
        }
        if (param.order_ && param.by_) {
            data = _.orderBy(data, param.order_, param.by_);
        }
        if (param.keyword_) {
            var val_1 = _.trim(param.keyword_).toLowerCase();
            if (val_1) {
                data = _.filter(data, function (item) {
                    var e_1, _a;
                    try {
                        for (var _b = __values(_this.columns), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var col = _c.value;
                            var field = col.dataIndex;
                            if (field && _.has(item, field) && _.isString(item[field])) {
                                return _.toLower(item[field]).indexOf(val_1) >= 0;
                            }
                        }
                    }
                    catch (e_1_1) { e_1 = { error: e_1_1 }; }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                        }
                        finally { if (e_1) throw e_1.error; }
                    }
                    return false;
                });
            }
        }
        else {
            _.keys(param).map(function (key) {
                if (_.endsWith(key, '_')) {
                    return;
                }
                var val = _.trim(param[key]).toLowerCase();
                if (val) {
                    data = _.filter(data, function (item) {
                        if (!_.has(item, key)) {
                            return false;
                        }
                        return _.toLower(item[key]).indexOf(val) >= 0;
                    });
                }
            });
        }
        var total = data.length;
        if (this.props.pagination !== false) {
            var start = param.start_ || 0;
            var count = param.count_ || this.state.pageSize;
            data.splice(0, start);
            data.splice(count);
        }
        this.setState({ data: data, total: total });
    };
    STable.prototype.componentDidMount = function () {
        var _a;
        var _this = this;
        var VLIST = window.VAP_GLOBAL.VLIST;
        this.fetchData(_.extend(this.param, (_a = {}, _a[VLIST.start] = 0, _a[VLIST.count] = this.state.pageSize, _a)));
        this.reMax();
        if (_.isArray(this.props.defaultSelectedKeys) && this.props.defaultSelectedKeys.length) {
            var selectedRowKeys_1 = [];
            var selectObjects_1 = [];
            var keySet_1 = new Set();
            this.props.defaultSelectedKeys.map(function (item) { return keySet_1.add(item + ''); });
            (this.props.dataSource || []).map(function (item) {
                var key = item[_this.rowKey] + '';
                if (keySet_1.has(key)) {
                    selectedRowKeys_1.push(item[_this.rowKey]);
                    selectObjects_1.push(item);
                }
            });
            this.setState({ selectedRowKeys: selectedRowKeys_1, selectObjects: selectObjects_1 });
        }
    };
    STable.prototype.componentDidUpdate = function (prevProps) {
        var _a;
        if (prevProps.dataSource.length != this.props.dataSource.length || prevProps.dataSource != this.props.dataSource) {
            var VLIST = window.VAP_GLOBAL.VLIST;
            this.fetchData(_.extend(this.param, (_a = {}, _a[VLIST.start] = 0, _a[VLIST.count] = this.state.pageSize, _a)));
        }
    };
    STable.prototype.onSelect = function (selectedRowKeys, selectObjects) {
        var _this = this;
        this.setState({ selectedRowKeys: selectedRowKeys, selectObjects: selectObjects }, function () {
            if (_this.props.onSelectedChange) {
                _this.props.onSelectedChange(selectedRowKeys, selectObjects);
            }
        });
    };
    STable.prototype.renderSelectBar = function () {
        var _this = this;
        if (!_.has(this.props, 'selectBar')) {
            return React.createElement(React.Fragment, null);
        }
        var style = {};
        if (this.mode == 'common') {
            style.maxHeight = this.state.maxHeight;
        }
        else {
            style.maxHeight = '100%';
        }
        return React.createElement(SelectBar_1.default, __assign({}, this.props.selectBar, { style: style, onSelect: function (key, object, parent) {
                var result = _this.props.selectBar.onSelect(key, object, parent);
                if (_.isPlainObject(result)) {
                    _this.query(result);
                }
            } }));
    };
    STable.prototype.reMax = function () {
        if (this.props.selectBar || this.mode != 'common') {
            var layout = document.getElementById(this.id);
            var height = 0;
            var searchBar = layout.getElementsByClassName('vap-table-search-bar');
            var table = layout.getElementsByClassName('ant-table-wrapper');
            var page = layout.getElementsByClassName('upagination');
            if (searchBar.length == 1) {
                // @ts-ignore
                height += searchBar[0].offsetHeight;
            }
            if (searchBar.length == 1) {
                // @ts-ignore
                height += table[0].offsetHeight;
            }
            if (page.length == 1) {
                // @ts-ignore
                height += page[0].offsetHeight;
            }
            if (height <= MIN_HEIGHT) {
                height = MIN_HEIGHT;
            }
            this.setState({ maxHeight: height });
        }
    };
    STable.prototype.renderSearchBar = function () {
        var _this = this;
        if (!_.has(this.props, 'searchBar')) {
            return React.createElement(React.Fragment, null);
        }
        var data = this.state.data;
        var selectedRowKeys = _.intersection(this.state.selectedRowKeys, (data || []).map(function (item) { return item[_this.rowKey]; }));
        if (_.has(this.props, 'keyword')) {
            return React.createElement(SearchKeyWord_1.default, __assign({ keyword: this.props.keyword, default: this.props.default, onSearch: function (param) { return _this.query(param); }, onChange: function (param) { return _.extend(_this.param, param); } }, this.props.searchBar, { selectedRowKeys: selectedRowKeys, selectObjects: this.state.selectObjects, param: this.param }));
        }
        return React.createElement(SearchBar_1.default, __assign({ onSearch: function (param) { return _this.query(param); }, onChange: function (param) { return _.extend(_this.param, param); }, default: this.props.default }, this.props.searchBar, { selectedRowKeys: selectedRowKeys, selectObjects: this.state.selectObjects, onExpands: function () { return _this.reMax(); }, param: this.param }));
    };
    STable.prototype.sorterField = function (sorter) {
        var _a;
        var VLIST = window.VAP_GLOBAL.VLIST;
        var query = (_a = {},
            _a[VLIST.start] = 0,
            _a[VLIST.count] = this.state.pageSize,
            _a);
        this.setState({ selectedRowKeys: [], selectObjects: [], current: 1, });
        if (_.has(sorter, 'field')) {
            query[VLIST.order] = sorter.field;
            query[VLIST.by] = sorter.order == 'ascend' ? 'asc' : 'desc';
        }
        _.extend(this.param, query);
        if (!_.has(sorter, 'order')) {
            _.unset(this.param, VLIST.order);
            _.unset(this.param, VLIST.by);
        }
        this.fetchData(_.extend({}, this.props.default, this.param));
    };
    STable.prototype.toPage = function (current, pageSize) {
        var _a;
        var _this = this;
        var VLIST = window.VAP_GLOBAL.VLIST;
        var resize = pageSize !== this.state.pageSize;
        var callback = function () { };
        if (resize) {
            callback = function () { return _this.reMax(); };
            window.setTimeout(function () { return _this.reMax(); }, 200);
        }
        var query = __assign(__assign({}, this.param), (_a = {}, _a[VLIST.start] = (current - 1) * pageSize, _a[VLIST.count] = pageSize, _a));
        this.param[VLIST.count] = pageSize;
        var state = {};
        state.pageSize = pageSize;
        state.current = current;
        this.setState(__assign({}, state));
        this.fetchData(_.extend({}, this.props.default, query));
    };
    STable.prototype.renderTable = function () {
        var _this = this;
        var data = this.state.data;
        var selectedRowKeys = [];
        var selectObjects = [];
        var rowSelection = undefined;
        if (this.props.select) {
            data.map(function (item) {
                if (_.indexOf(_this.state.selectedRowKeys, item[_this.rowKey]) >= 0) {
                    selectedRowKeys.push(item[_this.rowKey]);
                    selectObjects.push(item);
                }
            });
            rowSelection = {
                selectedRowKeys: selectedRowKeys,
                onChange: function (selectedRowKeys, selectObjects) { return _this.onSelect(selectedRowKeys, selectObjects); },
                getCheckboxProps: function (record) { return ({ disabled: !_.has(record, _this.rowKey) || (_this.props.selectDisabled && _this.props.selectDisabled(record)) }); },
            };
        }
        return React.createElement(antd_1.Table, __assign({ size: "small", rowClassName: function (item) { return _.has(item, '__EFFECT') ? 'row-high-' + item['__EFFECT'] : ''; }, locale: { emptyText: React.createElement(antd_1.Empty, null) } }, this.props, { rowKey: this.rowKey, columns: this.columns, dataSource: data, onChange: function (pagination, filters, sorter) { return _this.sorterField(sorter); }, rowSelection: rowSelection, pagination: false }));
    };
    STable.prototype.renderPagination = function () {
        var _this = this;
        var OPTIONS = window.VAP_GLOBAL.PAGINATION.OPTIONS;
        var _a = this.state, total = _a.total, current = _a.current;
        return React.createElement(UPagination_1.default, { onChange: function (page, pageSize) { return _this.toPage(page, pageSize); }, onShowSizeChange: function (page, pageSize) { return _this.toPage(page, pageSize); }, current: current, total: total, pageSize: this.state.pageSize, pageSizeOptions: _.get(this.props.pagination, 'pageSizeOptions') || OPTIONS });
    };
    STable.prototype.render = function () {
        var layoutStyle = {};
        if (this.mode == 'fixed') {
            var fixHeight = this.props.fixedHeight || 0;
            // @ts-ignore
            if (_.has(this.props._theme, 'contentHeight')) {
                // @ts-ignore
                layoutStyle.height = this.props._theme.contentHeight - fixHeight;
            }
        }
        var className = ['vap-table', 'vap-table-' + this.mode];
        if (this.props.fixedCol) {
            className.push('vap-table-fixcol');
        }
        return React.createElement(antd_1.Layout, { className: className.join(' '), style: layoutStyle },
            this.renderSelectBar(),
            React.createElement(antd_1.Layout, { id: this.id },
                this.renderSearchBar(),
                React.createElement(antd_1.Layout.Content, { className: "vap-table-content" }, this.renderTable()),
                this.props.pagination === false ? [] : React.createElement(antd_1.Layout.Footer, { className: "vap-table-footer" }, this.renderPagination())));
    };
    return STable;
}(React.PureComponent));
exports.default = (0, dva_1.connect)(function (_a) {
    var _theme = _a._theme;
    return ({ _theme: _theme });
})(STable);
