"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BUTTON_EXPORT = exports.BUTTON_IMPORT = exports.BUTTON_MORE = exports.BUTTON_DELETE = exports.BUTTON_ADD = exports.ACTION = exports.DELETE = exports.EDIT = exports.INFO = void 0;
var React = require("react");
var _ = require("lodash");
var antd_1 = require("antd");
var PageUtil_1 = require("../../utils/PageUtil");
var Popconfirm_1 = require("../rewrites/Popconfirm");
var Global_1 = require("../../utils/Global");
var DEFAULT_CLASS = {
    INFO: 'table-act-info',
    EDIT: 'table-act-edit',
    DELETE: 'table-act-delete',
};
var INFO = function (props) { return (props.roleCode == null || PageUtil_1.default.hasRole(props.roleCode)) && React.createElement("span", { className: "table-act-info", onClick: function (evt) { evt.preventDefault(); evt.stopPropagation(); props.onClick(); }, title: "\u67E5\u770B ".concat(props.name || '') },
    React.createElement(antd_1.Icon, { type: 'search' }),
    React.createElement("span", null, _.has(props, 'title') ? props.title : '查看')); };
exports.INFO = INFO;
var EDIT = function (props) { return (props.roleCode == null || PageUtil_1.default.hasRole(props.roleCode)) && React.createElement("span", { className: "table-act-edit", onClick: function (evt) { evt.preventDefault(); evt.stopPropagation(); props.onClick(); }, title: "\u7F16\u8F91 ".concat(props.name || '') },
    React.createElement(antd_1.Icon, { type: 'edit' }),
    React.createElement("span", null, _.has(props, 'title') ? props.title : '编辑')); };
exports.EDIT = EDIT;
var DELETE = function (props) {
    var title = React.createElement("span", null,
        "\u786E\u8BA4\u5220\u9664",
        React.createElement("b", null, props.name),
        "\u5417?");
    if (Global_1.default.GET('VTABLE')[0] && Global_1.default.GET('VTABLE')[0].DELETECONFIRMTITLE) {
        title = Global_1.default.GET('VTABLE')[0].DELETECONFIRMTITLE;
    }
    return (props.roleCode == null || PageUtil_1.default.hasRole(props.roleCode)) && React.createElement(Popconfirm_1.default, { onConfirm: function () { return props.onClick(); }, title: React.createElement("span", { className: "table-delete-tip" },
            title,
            " ") },
        React.createElement("span", { className: "table-act-delete", title: "\u5220\u9664 ".concat(props.name || ''), onClick: function (evt) { evt.preventDefault(); evt.stopPropagation(); } },
            React.createElement(antd_1.Icon, { type: 'delete' }),
            React.createElement("span", null, _.has(props, 'title') ? props.title : '删除')));
};
exports.DELETE = DELETE;
var ACTION = function (props) {
    if (_.has(props, 'roleCode') && !PageUtil_1.default.hasRole(props.roleCode)) {
        return [];
    }
    var className = _.has(DEFAULT_CLASS, props.type) ? DEFAULT_CLASS[props.type] : DEFAULT_CLASS.EDIT;
    if (!_.has(props, 'confrim')) {
        return React.createElement("span", { className: className, onClick: function (evt) { evt.preventDefault(); evt.stopPropagation(); props.onClick(); }, title: "".concat(props.name || '') },
            props.icon && React.createElement(antd_1.Icon, { type: props.icon }),
            React.createElement("span", null, props.title));
    }
    return React.createElement(Popconfirm_1.default, { onConfirm: function () { return props.onClick(); }, title: React.createElement("span", { className: "table-delete-tip" }, props.confrim) },
        React.createElement("span", { className: className, title: "".concat(props.name || ''), onClick: function (evt) { evt.preventDefault(); evt.stopPropagation(); } },
            props.icon && React.createElement(antd_1.Icon, { type: props.icon }),
            React.createElement("span", null, props.title)));
};
exports.ACTION = ACTION;
/**
 * 通用添加按钮
*/
var BUTTON_ADD = function (onClick, props) { return (__assign(__assign({ label: '添加', icon: 'plus', type: 'primary' }, props), { onClick: onClick })); };
exports.BUTTON_ADD = BUTTON_ADD;
/**
 * 通用删除按钮
*/
var BUTTON_DELETE = function (onClick, props) { return (__assign(__assign({ label: '删除', icon: 'delete', type: 'danger', mustSelect: true, confirm: '确认要删除选中的条目吗?' }, props), { onClick: onClick })); };
exports.BUTTON_DELETE = BUTTON_DELETE;
/**
 * 通用更多按钮，需要传子菜单
*/
var BUTTON_MORE = function (children) { return ({
    label: '更多',
    onClick: null,
    children: children
}); };
exports.BUTTON_MORE = BUTTON_MORE;
/**
 * 通用导入按钮
*/
var BUTTON_IMPORT = function (onClick, props) { return (__assign(__assign({ label: '导入', icon: 'import' }, props), { onClick: onClick })); };
exports.BUTTON_IMPORT = BUTTON_IMPORT;
/**
 * 通用导出按钮
*/
var BUTTON_EXPORT = function (onClick, props) { return (__assign(__assign({ label: '导出', icon: 'export' }, props), { onClick: onClick })); };
exports.BUTTON_EXPORT = BUTTON_EXPORT;
