"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ActionButton = void 0;
var React = require("react");
var _ = require("lodash");
var antd_1 = require("antd");
var Popconfirm_1 = require("../../_common/rewrites/Popconfirm");
var utils_1 = require("../../utils");
var ActionButton = /** @class */ (function (_super) {
    __extends(ActionButton, _super);
    function ActionButton() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ActionButton.prototype.renderButton = function (btn, selectedRowKeys, selectObjects, searchParam) {
        if (btn.children && btn.children.length > 0) {
            var btnParam = {};
            if (_.has(btn, 'type')) {
                btnParam.type = btn.type;
            }
            if (btn.onClick != null) {
                btnParam.onClick = function () { return btn.onClick(selectedRowKeys, selectObjects, searchParam); };
            }
            return React.createElement(antd_1.Dropdown, { overlay: React.createElement(antd_1.Menu, null, btn.children.map(function (item, key) {
                    var param = {
                        key: key,
                        onClick: function () { return item.onClick(selectedRowKeys, selectObjects, searchParam); },
                    };
                    if (item.mustSelect) {
                        param.disabled = true;
                        if (_.isArray(selectedRowKeys) && selectedRowKeys.length > 0) {
                            param.disabled = false;
                        }
                    }
                    return React.createElement(antd_1.Menu.Item, __assign({}, param),
                        item.icon && React.createElement(antd_1.Icon, { type: item.icon }),
                        "  ",
                        item.label);
                })) },
                React.createElement(antd_1.Button, __assign({}, btnParam),
                    btn.label,
                    " ",
                    React.createElement(antd_1.Icon, { type: "down" })));
        }
        var param = {};
        if (_.has(btn, 'icon')) {
            param.icon = btn.icon;
        }
        if (_.has(btn, 'type')) {
            param.type = btn.type;
        }
        if (btn.mustSelect) {
            param.disabled = true;
            if (_.isArray(selectedRowKeys) && selectedRowKeys.length > 0) {
                param.disabled = false;
            }
        }
        if (btn.confirm && param.disabled !== true) {
            if (_.isFunction(btn.confirm)) {
                return React.createElement(Popconfirm_1.default, { trigger: "click", placement: "bottomLeft", onConfirm: function () { return btn.onClick(selectedRowKeys, selectObjects, searchParam); }, title: btn.confirm(selectedRowKeys, selectObjects, searchParam) },
                    React.createElement(antd_1.Button, __assign({}, btn.config, param), btn.label));
            }
            return React.createElement(Popconfirm_1.default, { trigger: "click", placement: "bottomLeft", onConfirm: function () { return btn.onClick(selectedRowKeys, selectObjects); }, title: btn.confirm },
                React.createElement(antd_1.Button, __assign({}, btn.config, param), btn.label));
        }
        param.onClick = function () { return btn.onClick(selectedRowKeys, selectObjects, searchParam); };
        return React.createElement(antd_1.Button, __assign({}, btn.config, param), btn.label);
    };
    ActionButton.prototype.render = function () {
        var e_1, _a;
        var _this = this;
        var groups = [[]];
        try {
            for (var _b = __values(this.props.buttons), _c = _b.next(); !_c.done; _c = _b.next()) {
                var btn = _c.value;
                // @ts-ignore
                if (btn === false) {
                    continue;
                }
                if (btn == null) {
                    groups.push([]);
                    continue;
                }
                if (btn.roleCode && !utils_1.PageUtil.hasRole(btn.roleCode)) {
                    continue;
                }
                groups[groups.length - 1].push(btn);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return groups.map(function (group) { return React.createElement(antd_1.Button.Group, null, group.map(function (btn) { return _this.renderButton(btn, _this.props.selectedRowKeys, _this.props.selectObjects, _this.props.param); })); });
    };
    return ActionButton;
}(React.PureComponent));
exports.ActionButton = ActionButton;
