"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var _ = require("lodash");
var antd_1 = require("antd");
var ActionButton_1 = require("./ActionButton");
var _Util_1 = require("./_Util");
var default_1 = /** @class */ (function (_super) {
    __extends(default_1, _super);
    function default_1(props) {
        var _this = _super.call(this, props) || this;
        _this.fieldOutside = false;
        _this.cols = 3;
        _this.fieldWidth = 250;
        _this.labelWidth = 90;
        _this.SearchFilelds = [];
        _this.state = {
            __expand: false,
        };
        if (_.has(_this.props, 'cols')) {
            _this.cols = _this.props.cols;
        }
        if (_.has(_this.props, 'fieldWidth')) {
            if (_.isArray(_this.props.fieldWidth)) {
                _this.fieldWidth = _this.props.fieldWidth[0];
                _this.labelWidth = _this.props.fieldWidth[1];
            }
            else if (_.isNumber(_this.props.fieldWidth)) {
                _this.fieldWidth = _this.props.fieldWidth;
            }
        }
        return _this;
    }
    default_1.prototype.componentDidMount = function () {
        var _this = this;
        if (_.has(this.props, 'default') && this.props.fields && this.props.fields.length > 0) {
            var state_1 = {};
            this.props.fields.map(function (field) {
                if (field.type == 'timerange' || field.type == 'daterange') {
                    var _a = __read(field.field.split(','), 2), startField = _a[0], endField = _a[1];
                    if (_.has(_this.props.default, startField)) {
                        state_1[startField] = _this.props.default[startField];
                    }
                    if (_.has(_this.props.default, endField)) {
                        state_1[endField] = _this.props.default[endField];
                    }
                }
                if (_.has(_this.props.default, field.field)) {
                    state_1[field.field] = _this.props.default[field.field];
                }
            });
            this.setState(state_1);
        }
    };
    default_1.prototype.check = function (field, value) {
        var _a;
        var _this = this;
        var state = _.isPlainObject(value) ? value : (_a = {}, _a[field] = value, _a);
        this.setState(state, function () {
            if (_.isFunction(_this.props.onChange)) {
                _this.props.onChange(_this.getParam());
            }
        });
    };
    // 支持有 label 和 无 label 两种展现方式
    default_1.prototype.renderInput = function (field, rowIndex, fixInWidth) {
        var _this = this;
        if (rowIndex === void 0) { rowIndex = 0; }
        if (fixInWidth === void 0) { fixInWidth = 0; }
        var SearchField = (0, _Util_1.getSearchField)(field.type);
        // 弹出窗口、高级搜索模式
        if (fixInWidth) {
            var width = fixInWidth * (field.span || 1) - this.labelWidth;
            return React.createElement(React.Fragment, null,
                React.createElement("label", { style: { width: this.labelWidth }, className: "search-bar-field-label" }, field.label),
                React.createElement("div", { className: "search-bar-field-input search-bar-field-input-".concat(field.type) },
                    React.createElement(SearchField, { width: width, field: field, onChange: function (val) { return _this.check(field.field, val); }, triggerSearch: function () { return _this.search(); }, data: this.state })));
        }
        // label 在外模式
        if (this.fieldOutside) {
            var width = this.fieldWidth * (field.span || 1) - this.labelWidth;
            if (rowIndex > 0 && field.span == this.cols && (field.type == 'radio' || field.type == 'checkbox' || field.type == 'radiomore')) {
                width = "calc(100% - ".concat(this.labelWidth + 80, "px)");
            }
            return React.createElement(React.Fragment, null,
                React.createElement("label", { style: { width: this.labelWidth }, className: "search-bar-field-label" }, field.label),
                React.createElement("div", { className: "search-bar-field-input search-bar-field-input-".concat(field.type), style: { width: width } },
                    React.createElement(SearchField, { field: field, onChange: function (val) { return _this.check(field.field, val); }, triggerSearch: function () { return _this.search(); }, data: this.state })));
        }
        // label 在内模式
        return React.createElement(SearchField, { width: this.fieldWidth * (field.span || 1), field: field, onChange: function (val) { return _this.check(field.field, val); }, triggerSearch: function () { return _this.search(); }, data: this.state });
    };
    default_1.prototype.clear = function () {
        var _this = this;
        var state = {};
        _.keys(this.state).map(function (key) {
            if (!key.startsWith('__')) {
                state[key] = _.has(_this.props.default, key) ? _this.props.default[key] : '';
            }
        });
        this.setState(state);
    };
    default_1.prototype.getParam = function () {
        var _this = this;
        var query = {};
        _.keys(this.state).map(function (key) {
            if (!key.startsWith('__')) {
                if (_.has(_this.state, key)) {
                    if (_.isString(_this.state[key])) {
                        var txt = _.trim(_this.state[key]);
                        if (txt) {
                            query[key] = txt;
                        }
                        else {
                            query[key] = null;
                        }
                    }
                    else {
                        query[key] = _this.state[key];
                    }
                }
                else {
                    query[key] = null;
                }
            }
        });
        return query;
    };
    default_1.prototype.search = function () {
        var param = this.getParam();
        this.props.onSearch(param);
    };
    default_1.prototype.expand = function (__expand) {
        var _this = this;
        this.setState({ __expand: __expand }, function () {
            if (_this.props.onExpands) {
                _this.props.onExpands();
            }
        });
    };
    default_1.prototype.renderButtons = function () {
        if (!_.has(this.props, 'buttons')) {
            return [];
        }
        return React.createElement(ActionButton_1.ActionButton, { buttons: this.props.buttons, selectedRowKeys: this.props.selectedRowKeys, selectObjects: this.props.selectObjects, param: this.props.param });
    };
    default_1.prototype.renderAdvanceModal = function () {
        var _this = this;
        var title = '高级搜索';
        var width = 988;
        var cols = this.cols;
        if (!_.isBoolean(this.props.useModal)) {
            if (_.has(this.props.useModal, 'title')) {
                title = this.props.useModal.title;
            }
            if (_.has(this.props.useModal, 'width')) {
                width = this.props.useModal.width;
            }
        }
        var fixedWidth = (width - 50) / cols;
        return React.createElement(antd_1.Modal, { width: width, title: title, visible: this.state.__expand, onOk: function () { return _this.setState({ __expand: false }, function () { return _this.search(); }); }, onCancel: function () { return _this.setState({ __expand: false }); }, okText: React.createElement("span", null,
                React.createElement(antd_1.Icon, { type: "search" }),
                " \u67E5\u8BE2") },
            React.createElement(antd_1.Row, { className: "vap-table-search-bar  vap-table-search-bar-expand" },
                React.createElement(antd_1.Col, { className: "vap-table-search-bar-input" }, this.SearchFilelds.map(function (row, i) { return React.createElement(antd_1.Input.Group, { compact: false, className: 'search-bar-outside' }, row.map(function (field) { return _this.renderInput(field, i, fixedWidth); })); }))));
    };
    default_1.prototype.render = function () {
        var _this = this;
        var rowUse = 0;
        var hasLabel = this.props.fieldOutside || false;
        this.SearchFilelds = [];
        if (_.has(this.props, 'fields') && this.props.fields.length > 0) {
            this.SearchFilelds.push([]);
            this.props.fields.map(function (field) {
                if (field.show === false) {
                    return;
                }
                var row = _this.SearchFilelds[_this.SearchFilelds.length - 1];
                var span = field.span || 1;
                if (hasLabel || (0, _Util_1.isSearchFieldOutSide)(field.type)) {
                    hasLabel = true;
                }
                var tryfill = rowUse + span;
                if (tryfill > _this.cols) {
                    _this.SearchFilelds.push([field]);
                    rowUse = span;
                }
                else {
                    row.push(field);
                    rowUse += span;
                }
            });
        }
        this.fieldOutside = hasLabel;
        var useModal = _.has(this.props, 'useModal') && this.props.useModal != false;
        return React.createElement(React.Fragment, null,
            React.createElement(antd_1.Row, { className: "vap-table-search-bar " + (this.state.__expand ? "vap-table-search-bar-expand" : "") + this.props.className }, !useModal && this.state.__expand ? React.createElement(antd_1.Col, { className: "vap-table-search-bar-input" },
                this.SearchFilelds.map(function (row, i) { return React.createElement(antd_1.Input.Group, { compact: !_this.fieldOutside, className: _this.fieldOutside ? 'search-bar-outside' : 'search-bar-inside' },
                    row.map(function (field) { return _this.renderInput(field, i); }),
                    i == 0 && React.createElement("div", { className: "vap-table-search-bar-btns" }, _this.renderButtons())); }),
                React.createElement(antd_1.Input.Group, { className: "vap-table-search-bar-actions", style: { paddingLeft: this.fieldOutside ? this.labelWidth : 0 } },
                    this.props.onSearch && React.createElement(antd_1.Button, { icon: "search", onClick: function (e) { return _this.search(); }, type: "primary" }, "\u67E5\u8BE2"),
                    React.createElement(antd_1.Button, { icon: "redo", type: "ghost", onClick: function (e) { return _this.clear(); } }, "\u91CD\u7F6E"),
                    React.createElement(antd_1.Button, { icon: "filter", onClick: function (e) { return _this.expand(false); } }, "\u66F4\u5C11\u6761\u4EF6"))) : React.createElement(antd_1.Col, { className: "vap-table-search-bar-input" },
                React.createElement(antd_1.Input.Group, { compact: !this.fieldOutside, className: this.fieldOutside ? 'search-bar-outside' : 'search-bar-inside' },
                    (this.SearchFilelds.length > 0) && React.createElement(React.Fragment, null,
                        this.SearchFilelds[0].map(function (field) { return _this.renderInput(field); }),
                        this.props.onSearch && React.createElement(antd_1.Button, { icon: "search", type: "primary", title: "\u67E5\u8BE2", onClick: function (e) { return _this.search(); } }),
                        React.createElement(antd_1.Button, { icon: "redo", type: "ghost", title: "\u91CD\u7F6E", onClick: function (e) { return _this.clear(); } }),
                        this.SearchFilelds.length > 1 && React.createElement(antd_1.Button, { icon: "filter", onClick: function (e) { return _this.expand(true); }, title: "\u66F4\u591A\u6761\u4EF6" })),
                    React.createElement("div", { className: "vap-table-search-bar-btns" }, this.renderButtons())))),
            useModal && this.SearchFilelds.length > 1 && this.renderAdvanceModal());
    };
    return default_1;
}(React.PureComponent));
exports.default = default_1;
