"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var _ = require("lodash");
var antd_1 = require("antd");
var _Util_1 = require("./_Util");
var PageUtil_1 = require("../../utils/PageUtil");
var default_1 = /** @class */ (function (_super) {
    __extends(default_1, _super);
    function default_1() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            collapsed: false,
            searchValue: '',
        };
        return _this;
    }
    default_1.prototype.renderSelect = function () {
        var _this = this;
        var Left = (0, _Util_1.getSelectBar)(this.props.type);
        if (Left == null) {
            return React.createElement("div", null);
        }
        var param = {
            config: this.props.config,
            onSelect: function (key, node, parent) { return _this.props.onSelect(key, node, parent); }
        };
        if (this.props.filter || (_.has(this.props.config, 'filter') && this.props.config.filter)) {
            param.searchValue = this.state.searchValue;
        }
        return React.createElement(Left, __assign({}, param));
    };
    default_1.prototype.check = function (searchValue) {
        this.setState({ searchValue: searchValue });
    };
    default_1.prototype.renderAction = function () {
        // select-extra-actions
        // {_.has(this.props, 'actions') && <div className="select-extra-actions">{this.props.actions}</div>}
        if (this.props.btns && this.props.btns.length) {
            return React.createElement("span", { className: "select-extra-btns" },
                " ",
                this.props.btns.map(function (btn) {
                    if (_.has(btn, 'show')) {
                        if (!btn.show) {
                            return [];
                        }
                    }
                    if (_.has(btn, 'roleCode')) {
                        if (!PageUtil_1.default.hasRole(btn.roleCode)) {
                            return [];
                        }
                    }
                    if (btn.confirm) {
                        return React.createElement(antd_1.Popconfirm, { title: btn.confirm, onConfirm: function (evt) { return btn.onClick(); } },
                            React.createElement("span", { className: 'select-extra-btns-item', title: btn.title },
                                React.createElement(antd_1.Icon, { type: btn.icon }),
                                btn.text));
                    }
                    return React.createElement("span", { className: 'select-extra-btns-item', title: btn.title, onClick: function (evt) {
                            evt.preventDefault();
                            evt.stopPropagation();
                            btn.onClick();
                        } },
                        React.createElement(antd_1.Icon, { type: btn.icon }),
                        btn.text);
                }));
        }
        if (this.props.actions) {
            return React.createElement("span", { className: "select-extra-actions" }, this.props.actions);
        }
        return [];
    };
    default_1.prototype.renderTitle = function () {
        var _this = this;
        if (this.props.filter || (_.has(this.props.config, 'filter') && this.props.config.filter)) {
            return React.createElement(React.Fragment, null,
                React.createElement("span", { className: "select-trigger-close", title: "\u6536\u8D77", onClick: function () { return _this.setState({ collapsed: !_this.state.collapsed }); } },
                    React.createElement(antd_1.Icon, { type: "left-circle" })),
                React.createElement(antd_1.Input, { size: "small", className: "select-search-input", placeholder: this.props.title, onChange: function (evt) { return _this.check(evt.target.value); } }),
                this.renderAction());
        }
        return React.createElement(React.Fragment, null,
            React.createElement("span", { className: "select-trigger-close", title: "\u6536\u8D77", onClick: function () { return _this.setState({ collapsed: !_this.state.collapsed }); } },
                React.createElement(antd_1.Icon, { type: "left-circle" })),
            this.props.title,
            this.renderAction());
    };
    default_1.prototype.render = function () {
        var _this = this;
        var width = this.props.width || 250;
        var param = { style: {} };
        if (this.props.style) {
            _.extend(param.style, {}, this.props.style);
        }
        return React.createElement(antd_1.Layout.Sider, __assign({ collapsed: this.state.collapsed, className: "vap-select-bar", width: width }, param),
            React.createElement(antd_1.Card, { className: "select-bar-card", bodyStyle: { padding: 0 }, title: this.renderTitle(), style: { width: width }, bordered: false }, this.renderSelect()),
            React.createElement("div", { className: "select-trigger-open", title: "\u5C55\u5F00", onClick: function () { return _this.setState({ collapsed: !_this.state.collapsed }); }, style: { display: this.state.collapsed ? 'block' : 'none' } }));
    };
    return default_1;
}(React.PureComponent));
exports.default = default_1;
