"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UForm = void 0;
var React = require("react");
var _ = require("lodash");
var antd_1 = require("antd");
var _FormLayout_1 = require("./_FormLayout");
var _Util_1 = require("./_Util");
var PageUtil_1 = require("../../utils/PageUtil");
// 给 Rules 添加 Message
var ruleMessage = function (field, requiredMap, rules) {
    rules.map(function (item) {
        if (!_.has(item, 'message')) {
            if (item.required) {
                item.message = "".concat(field.title, " \u4E3A\u5FC5\u586B\u9879\uFF01");
            }
            else {
                item.message = "".concat(field.title, " \u683C\u5F0F\u6709\u8BEF");
            }
        }
    });
    if (requiredMap.has(field.field)) {
        var required = requiredMap.get(field.field);
        var idx = _.findIndex(rules, function (rule) { return _.has(rule, 'required'); });
        if (idx >= 0) {
            rules[idx].required = required;
        }
        else if (required) {
            rules.push({ required: true, message: "".concat(field.title, " \u4E3A\u5FC5\u586B\u9879\uFF01") });
        }
    }
};
var UForm = exports.UForm = /** @class */ (function (_super) {
    __extends(UForm, _super);
    function UForm() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.reOptions = new Map();
        _this.reRequired = new Map();
        return _this;
    }
    UForm.prototype.componentDidMount = function () {
        var _this = this;
        var state = _super.prototype.componentDidMount.call(this);
        if (!this.isEdit) {
            if (_.keys(this.props.default).length == 0) {
                return;
            }
        }
        var values = __assign(__assign({}, this.props.default), this.props.data);
        if (state.isGroup) {
            this.props.fields.map(function (group) { return group.fields.map(function (field) {
                if (field.link == null || field.link.length == 0) {
                    return;
                }
                if (_this.disableFields.has(field.field)) {
                    return;
                }
                _this.getValueFromEvent(field, values);
            }); });
        }
        else {
            this.props.fields.map(function (field) {
                if (field.link == null || field.link.length == 0) {
                    return;
                }
                if (_this.disableFields.has(field.field)) {
                    return;
                }
                _this.getValueFromEvent(field, values);
            });
        }
        return null;
    };
    UForm.prototype.shouldComponentUpdate = function (old) {
        //@ts-ignore
        if (_.has(this.props, 'visible') && this.props.visible === false) {
            return false;
        }
        return true;
    };
    // 转value
    UForm.prototype.getValueFromEvent = function (field, values, extra) {
        var e_1, _a, e_2, _b;
        var _this = this;
        var value = values[field.field];
        if (!_.isArray(field.link) || field.link.length == 0) {
            if (field.field.indexOf(',') > 0) {
                this.props.form.setFieldsValue(values);
            }
            return value;
        }
        try {
            for (var _c = __values(field.link), _d = _c.next(); !_d.done; _d = _c.next()) {
                var link = _d.value;
                var resp = link.call(value, __assign(__assign({}, this.props.form.getFieldsValue()), values), extra);
                if (_.isPlainObject(extra) && link.field.indexOf(',') > 0) {
                    var fileds = link.field.split(',');
                    try {
                        for (var fileds_1 = (e_2 = void 0, __values(fileds)), fileds_1_1 = fileds_1.next(); !fileds_1_1.done; fileds_1_1 = fileds_1.next()) {
                            var f = fileds_1_1.value;
                            if (_.has(extra, f)) {
                                values[f] = extra[f];
                            }
                        }
                    }
                    catch (e_2_1) { e_2 = { error: e_2_1 }; }
                    finally {
                        try {
                            if (fileds_1_1 && !fileds_1_1.done && (_b = fileds_1.return)) _b.call(fileds_1);
                        }
                        finally { if (e_2) throw e_2.error; }
                    }
                }
                if (_.isString(resp) || _.isNumber(resp) || _.isBoolean(resp)) {
                    values[link.field] = resp;
                }
                else {
                    var result = resp;
                    if (_.has(resp, 'disabled')) {
                        if (result.disabled) {
                            this.disableFields.add(link.field);
                        }
                        else {
                            this.disableFields.delete(link.field);
                        }
                    }
                    if (_.has(result, 'show')) {
                        if (result.show) {
                            this.hiddFields.delete(link.field);
                        }
                        else {
                            this.hiddFields.add(link.field);
                        }
                    }
                    if (_.has(result, 'value')) {
                        values[link.field] = result.value;
                    }
                    if (_.has(result, 'options')) {
                        if (result.options === null) {
                            this.reOptions.delete(link.field);
                        }
                        else {
                            this.reOptions.set(link.field, result.options);
                        }
                    }
                    if (_.has(result, 'required')) {
                        this.reRequired.set(link.field, result.required);
                    }
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
            }
            finally { if (e_1) throw e_1.error; }
        }
        setTimeout(function () { return _this.props.form.setFieldsValue(values); }, 2);
        return value;
    };
    UForm.prototype.getFiled = function (component, field) {
        var node = React.createElement(component.element, {
            form: this.props.form,
            field: field,
            disabled: this.disableFields.has(field.field),
            options: (this.reOptions.has(field.field) ? this.reOptions.get(field.field) : undefined)
        });
        return node;
    };
    UForm.prototype.renderField = function (component, field, ignoreRule) {
        var e_3, _a, e_4, _b;
        var _this = this;
        if (ignoreRule === void 0) { ignoreRule = false; }
        var form = this.props.form;
        var data = __assign(__assign({}, this.props.default), this.props.data);
        var rules = [];
        if (!ignoreRule) {
            if (_.isArray(field.rule) && field.rule.length) {
                try {
                    for (var _c = __values(field.rule), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var item = _d.value;
                        rules.push(__assign({}, item));
                    }
                }
                catch (e_3_1) { e_3 = { error: e_3_1 }; }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
                    }
                    finally { if (e_3) throw e_3.error; }
                }
            }
            if (component.rule) {
                var extendRules = [];
                if (_.isFunction(component.rule)) {
                    extendRules = component.rule(field) || [];
                }
                else {
                    extendRules = component.rule || [];
                }
                extendRules.map(function (item) { return rules.push(item); });
            }
        }
        ruleMessage(field, this.reRequired, rules);
        if (field.field.indexOf(',') < 0) {
            var initialValue_1 = _.has(data, field.field) ? data[field.field] : null;
            return form.getFieldDecorator(field.field, { initialValue: initialValue_1, validateFirst: true, rules: rules, getValueFromEvent: function (values, extra) { return _this.getValueFromEvent(field, values, extra); } })(this.getFiled(component, field));
        }
        var fields = field.field.split(',');
        var root = [];
        var initialValue = null;
        try {
            for (var fields_1 = __values(fields), fields_1_1 = fields_1.next(); !fields_1_1.done; fields_1_1 = fields_1.next()) {
                var key = fields_1_1.value;
                if (_.has(data, key) && data[key] !== null && data[key] !== '') {
                    initialValue = true;
                    break;
                }
            }
        }
        catch (e_4_1) { e_4 = { error: e_4_1 }; }
        finally {
            try {
                if (fields_1_1 && !fields_1_1.done && (_b = fields_1.return)) _b.call(fields_1);
            }
            finally { if (e_4) throw e_4.error; }
        }
        root.push(form.getFieldDecorator(field.field, { initialValue: initialValue, validateFirst: true, rules: rules, getValueFromEvent: function (values, extra) { return _this.getValueFromEvent(field, values, extra); } })(this.getFiled(component, field)));
        fields.map(function (hiddenKey) {
            root.push(form.getFieldDecorator(hiddenKey, { initialValue: data[hiddenKey] })(React.createElement("input", { type: "hidden" })));
        });
        return root;
    };
    UForm.prototype.renderLabel = function (field) {
        return field.tip ? React.createElement("span", null,
            field.title,
            React.createElement(antd_1.Popover, { placement: "top", content: field.tip },
                React.createElement(antd_1.Icon, { type: "question-circle", style: { marginLeft: 4, cursor: 'pointer' } }))) : field.title;
    };
    UForm.prototype.renderAction = function () {
        var _a;
        var _this = this;
        var btns = (_.has(this.props, 'buttons') && _.isArray(this.props.buttons)) ? this.props.buttons.filter(function (item) {
            if (_.has(item, 'roleCode') && item.roleCode) {
                if (!PageUtil_1.default.hasRole(item.roleCode)) {
                    return false;
                }
            }
            return true;
        }) : [];
        if (btns.length == 0) {
            return [];
        }
        var cols = (_a = this.state, _a.cols), LABELSPAN = _a.LABELSPAN;
        var labelSpan = LABELSPAN / cols;
        var inputSpan = 24 - labelSpan;
        return React.createElement(antd_1.Col, { span: 24 },
            React.createElement(antd_1.Row, null,
                React.createElement(antd_1.Col, { span: labelSpan }),
                React.createElement(antd_1.Col, { span: inputSpan, className: 'uform-actions' }, btns.map(function (btn) {
                    var onClick = function (evt) {
                        evt.preventDefault();
                        evt.stopPropagation();
                    };
                    switch (btn.action) {
                        case 'button':
                            onClick = function (evt) {
                                evt.preventDefault();
                                evt.stopPropagation();
                                if (btn.onClick) {
                                    btn.onClick(_this.props.form.getFieldsValue());
                                }
                            };
                            break;
                        case 'reset':
                            onClick = function (evt) {
                                evt.preventDefault();
                                evt.stopPropagation();
                                _this.props.form.resetFields();
                                if (btn.onClick) {
                                    btn.onClick(_this.props.form.getFieldsValue());
                                }
                            };
                            break;
                        default:
                            onClick = function (evt) {
                                evt.preventDefault();
                                evt.stopPropagation();
                                _this.props.form.validateFields(function (err, values) {
                                    if (err) {
                                        return;
                                    }
                                    if (btn.onClick) {
                                        btn.onClick(values);
                                        return;
                                    }
                                    console.error('必须设置onClick参数');
                                });
                            };
                            break;
                    }
                    if (btn.confirm) {
                        return React.createElement(antd_1.Popconfirm, { title: btn.confirm, onConfirm: function (evt) { return onClick(evt); } },
                            React.createElement(antd_1.Button, __assign({}, btn, { onClick: undefined }), btn.text));
                    }
                    return React.createElement(antd_1.Button, __assign({}, btn, { onClick: function (evt) { return onClick(evt); } }), btn.text);
                }))));
    };
    UForm.prototype.renderForm = function (fields) {
        var _a;
        var _this = this;
        var cols = (_a = this.state, _a.cols), INPUTSPAN = _a.INPUTSPAN, LABELSPAN = _a.LABELSPAN, COLSPAN = _a.COLSPAN;
        return React.createElement(antd_1.Row, { type: 'flex' },
            " ",
            fields.map(function (item) {
                //@ts-ignore
                if (item == null || item === false) {
                    return [];
                }
                var component = (0, _Util_1.getInputComponent)(item.type);
                if (_this.hiddFields.has(item.field)) {
                    return React.createElement("div", { style: { display: 'none' } }, _this.renderField(component, item, true));
                }
                var ignoreRule = _this.disableFields.has(item.field);
                if (component.breakTitle) {
                    return React.createElement(antd_1.Col, { span: 24 },
                        React.createElement(antd_1.Form.Item, { labelCol: { span: 0 }, wrapperCol: { span: 24 } }, _this.renderField(component, item, ignoreRule)));
                }
                if (cols == 1) {
                    return React.createElement(antd_1.Col, { span: COLSPAN },
                        React.createElement(antd_1.Form.Item, { extra: item.extra, labelCol: { span: LABELSPAN }, wrapperCol: { span: INPUTSPAN }, label: _this.renderLabel(item) }, _this.renderField(component, item, ignoreRule)));
                }
                if (component.breakCol) {
                    var labelSpan = LABELSPAN / cols;
                    var inputSpan = 24 - labelSpan;
                    // 强行占据整行
                    return React.createElement(antd_1.Col, { span: 24 },
                        React.createElement(antd_1.Form.Item, { extra: item.extra, labelCol: { span: labelSpan }, wrapperCol: { span: inputSpan }, label: _this.renderLabel(item) }, _this.renderField(component, item, ignoreRule)));
                }
                var span = item.span || 1;
                if (span == 1) {
                    // rendered += span;
                    return React.createElement(antd_1.Col, { span: COLSPAN },
                        React.createElement(antd_1.Form.Item, { extra: item.extra, labelCol: { span: LABELSPAN }, wrapperCol: { span: INPUTSPAN }, label: _this.renderLabel(item) }, _this.renderField(component, item, ignoreRule)));
                }
                var colSpan = COLSPAN * span;
                colSpan = colSpan > 24 ? 24 : colSpan;
                var labelSpan = LABELSPAN / span;
                var inputSpan = 24 - labelSpan;
                return React.createElement(antd_1.Col, { span: colSpan },
                    React.createElement(antd_1.Form.Item, { extra: item.extra, labelCol: { span: labelSpan }, wrapperCol: { span: inputSpan }, label: _this.renderLabel(item) }, _this.renderField(component, item, ignoreRule)));
            }));
    };
    UForm.prototype.checkFields = function (fields) {
        var e_5, _a;
        try {
            for (var fields_2 = __values(fields), fields_2_1 = fields_2.next(); !fields_2_1.done; fields_2_1 = fields_2.next()) {
                var field = fields_2_1.value;
                if (!this.hiddFields.has(field.field)) {
                    return true;
                }
            }
        }
        catch (e_5_1) { e_5 = { error: e_5_1 }; }
        finally {
            try {
                if (fields_2_1 && !fields_2_1.done && (_a = fields_2.return)) _a.call(fields_2);
            }
            finally { if (e_5) throw e_5.error; }
        }
        return false;
    };
    UForm.prototype.renderGroup = function (group) {
        var _this = this;
        return group.map(function (item) {
            if (_this.checkFields(item.fields)) {
                return React.createElement("div", { className: "uform-group-item" },
                    React.createElement("h2", null, item.title),
                    _this.renderForm(item.fields));
            }
            return React.createElement(React.Fragment, null);
        });
    };
    //手风琴模式
    // renderCollapse(group: UFormFieldGroup[]) {
    //     const getFieldsError = this.props.form.getFieldsError();
    //     return <Collapse
    //         defaultActiveKey={['0_uform_collapse']}
    //         expandIcon={({ isActive }) => <Icon type="caret-right" rotate={isActive ? 90 : 0} />}
    //     >
    //         {group.map((item, index) => {
    //             let isError = false;
    //             const fields = item.fields.map(item => item.field)
    //             fields.map(item => {
    //                 if (getFieldsError[item])
    //                     isError = true;
    //             })
    //             return <Collapse.Panel header={<span className={isError ? 'high' : ''}>{item.title}</span>} key={index + '_uform_collapse'} style={{
    //                 borderRadius: 4,
    //                 // marginBottom: 24,
    //                 border: 0,
    //                 overflow: 'hidden',
    //             }}>
    //                 {this.renderForm(item.fields)}
    //             </Collapse.Panel>
    //         }
    //         )}
    //     </Collapse>
    // }
    // //标签页模式
    // renderTabs(group: UFormFieldGroup[]) {
    //     const getFieldsError = this.props.form.getFieldsError();
    //     return <Tabs defaultActiveKey="0_uform_tabs">
    //         {group.map((item, index) => {
    //             let isError = false;
    //             const fields = item.fields.map(item => item.field)
    //             fields.map(item => {
    //                 if (getFieldsError[item])
    //                     isError = true;
    //             })
    //             return <Tabs.TabPane tab={<span className={isError ? 'high' : ''}>{item.title}</span>} key={index + '_uform_tabs'}>
    //                 {this.renderForm(item.fields)}
    //             </Tabs.TabPane>
    //         }
    //         )}
    //     </Tabs>
    // }
    UForm.prototype.render = function () {
        if (this.state.loading) {
            return [];
        }
        var fields = this.props.fields;
        var isGroup = this.state.isGroup;
        var clazz = ['uform'];
        if (this.props.className) {
            clazz.push(this.props.className);
        }
        if (isGroup) {
            clazz.push('uform-group');
            // if (this.props.groupType == 'collapse') {
            //     return <Form className={clazz.join(' ')}>{this.renderCollapse(fields as UFormFieldGroup[])}</Form>
            // }
            // if (this.props.groupType == 'tabs') {
            //     return <Form className={clazz.join(' ')}>{this.renderTabs(fields as UFormFieldGroup[])}</Form>
            // }
            return React.createElement(antd_1.Form, { className: clazz.join(' ') },
                this.renderGroup(fields),
                this.renderAction());
        }
        return React.createElement(antd_1.Form, { className: clazz.join(' ') },
            this.renderForm(fields),
            this.renderAction());
    };
    UForm.create = function () {
        return antd_1.Form.create()(UForm);
    };
    return UForm;
}(_FormLayout_1._BaseUForm));
