"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getInputComponent = exports.registerInputType = exports.getFormLayout = void 0;
var _ = require("lodash");
var LAYOUTS = {
    common: [880, 2],
    simple: [640, 1],
    compress: [1080, 3],
};
var COLS_2 = 8;
var getFormLayout = function (props) {
    var _a, _b, _c;
    var layout = { isGroup: false, width: 640, cols: 1, };
    var child = props.fields[0];
    if (_.has(child, 'fields')) {
        layout.isGroup = true;
    }
    if (props.layout && _.has(LAYOUTS, props.layout)) {
        _a = __read(LAYOUTS[props.layout], 2), layout.width = _a[0], layout.cols = _a[1];
    }
    else {
        var len = 0;
        if (layout.isGroup) {
            len = _.sum(props.fields.map(function (item) { return _.filter(item.fields, function (v) { return v; }).length; }));
        }
        else {
            len = _.filter(props.fields, function (item) { return item; }).length;
        }
        if (len < COLS_2) {
            _b = __read(LAYOUTS.simple, 2), layout.width = _b[0], layout.cols = _b[1];
        }
        else {
            _c = __read(LAYOUTS.common, 2), layout.width = _c[0], layout.cols = _c[1];
        }
    }
    // @ts-ignore
    if (_.has(props, 'width') && _.isNumber(props.width) && props.width) {
        layout.width = props.width;
    }
    return layout;
};
exports.getFormLayout = getFormLayout;
if (!_.has(window, '_FORM_CONTENTS'))
    window['_FORM_CONTENTS'] = new Map();
var FORM_MAP = window['_FORM_CONTENTS'];
var registerInputType = function (type, element, options) {
    if (options === void 0) { options = null; }
    if (FORM_MAP.has(type)) {
        console.warn("".concat(type, " is aready registered"));
        return;
    }
    var component = {
        element: element,
        breakCol: false,
        breakDes: false,
        breakTitle: false,
        show: null,
        rule: null,
    };
    if (options) {
        if (options.breakCol)
            component.breakCol = true;
        if (options.breakTitle)
            component.breakTitle = true;
        if (options.breakDes)
            component.breakDes = true;
        if (options.show)
            component.show = options.show;
        if (options.rule)
            component.rule = options.rule;
    }
    FORM_MAP.set(type, component);
};
exports.registerInputType = registerInputType;
var getInputComponent = function (type) { return FORM_MAP.get(FORM_MAP.has(type) ? type : 'text'); };
exports.getInputComponent = getInputComponent;
