import * as React from 'react';
import { TreeAction, BaseTreeOpts } from './interface';
import { INSER_POS } from './_Utils';
import { BaseTree, BaseTreeState } from './BaseTree';
interface ActionTreeState extends BaseTreeState {
    readonly editKey: string;
    readonly editIdx: number[];
    readonly showAdd: boolean;
    readonly showEdit: boolean;
    readonly editMode: boolean;
    readonly editPos: INSER_POS;
    readonly editObject: any;
}
export declare abstract class ActionTree<T extends BaseTreeOpts & TreeAction> extends BaseTree<T, ActionTreeState> {
    actions: TreeAction;
    constructor(props: any);
    abstract getChildren(parentId: any): Promise<any[]>;
    abstract clearCache(parentId: string): void;
    state: Readonly<ActionTreeState>;
    private initAction;
    addRoot(data: any): Promise<void>;
    private addInner;
    private add;
    updateData(data: any, pos?: number[]): Promise<void>;
    private update;
    private deleteNode;
    private up;
    private down;
    renderTitle(node: any, title: string, keyword: string, idx: number, len: number, pos: number[]): JSX.Element;
    renderForm(): JSX.Element;
    private renderFixRoot;
    renderRoot(data: any[]): React.ReactNode;
}
export {};
