import * as React from 'react';
import { BaseTreeOpts, TreeNodeData } from './interface';
import { TreeProps, AntTreeNodeProps, AntTreeNodeSelectedEvent } from 'antd/lib/tree/Tree';
export interface BaseTreeState {
    readonly loading: boolean;
    readonly face: any;
    readonly selectedKeys: string[];
    readonly tree: TreeNodeData[];
    readonly keyword: string;
    readonly searchPos: Set<string>;
}
export declare const DEFAULT_STATE: BaseTreeState;
export declare abstract class BaseTree<T extends BaseTreeOpts, S extends BaseTreeState> extends React.Component<T, S> {
    state: Readonly<S>;
    fields: BaseTreeOpts;
    constructor(props: any);
    onSelect(selectedKeys: any, evt: AntTreeNodeSelectedEvent): void;
    componentDidUpdate(prevProps: any): void;
    /**
     * 获取树的基础展示外观参数
    */
    getFace(): TreeProps;
    search(keyword: string): void;
    searchNode(node: any, pos: number[], word: string, result: string[]): void;
    searchNodes(data: any[], pos: number[], word: string, result: string[]): void[];
    renderTitle(node: any, title: string, keyword: string, idx: number, len: number, pos: number[]): React.ReactNode;
    getNodeParam(node: any, keyword: any, pos: any, len: any, position: any): AntTreeNodeProps;
    renderNode(node: any, pos: number[], len: number): JSX.Element;
    renderNodes(data: any[], pos: number[]): JSX.Element[];
    renderRoot(data: any[]): React.ReactNode;
    abstract render(): React.ReactNode;
}
