"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseTree = exports.DEFAULT_STATE = void 0;
var React = require("react");
var _ = require("lodash");
var antd_1 = require("antd");
var HighLight_1 = require("../../utils/HighLight");
exports.DEFAULT_STATE = {
    loading: true,
    face: {},
    selectedKeys: [],
    tree: [],
    keyword: null,
    searchPos: null,
};
var BaseTree = /** @class */ (function (_super) {
    __extends(BaseTree, _super);
    function BaseTree(props) {
        var _this = _super.call(this, props) || this;
        _this.state = __assign({}, exports.DEFAULT_STATE);
        _this.fields = {
            rootCode: '0',
            keyField: 'id',
            titleField: 'name',
        };
        if (_.has(props, 'rootCode')) {
            _this.fields.rootCode = props.rootCode;
        }
        if (_.has(props, 'keyField')) {
            _this.fields.keyField = props.keyField;
        }
        if (_.has(props, 'titleField')) {
            _this.fields.titleField = props.titleField;
        }
        if (_.has(props, 'iconField')) {
            _this.fields.iconField = props.iconField;
        }
        if (_.has(_this.props, 'sortField')) {
            _this.fields.sortField = props.sortField;
        }
        if (_.has(_this.props, 'parentField')) {
            _this.fields.parentField = props.parentField;
        }
        return _this;
    }
    BaseTree.prototype.onSelect = function (selectedKeys, evt) {
        var _this = this;
        if (selectedKeys.length == 0) {
            if (this.props.mustSelect !== true) {
                this.setState({ selectedKeys: selectedKeys }, function () { return _this.props.onSelect(null, null, null); });
            }
            return;
        }
        var pos = (evt.selectedNodes[0].props.pos || '').split('-');
        var parent = null;
        if (pos.length > 1) {
            pos.pop();
            parent = _.get(this.state.tree, pos.map(function (i) { return "[".concat(i, "]"); }).join('.children'));
        }
        this.setState({ selectedKeys: selectedKeys }, function () { return _this.props.onSelect(selectedKeys[0], evt.selectedNodes[0].props.dataRef, parent, evt.selectedNodes[0].props.pos); });
    };
    BaseTree.prototype.componentDidUpdate = function (prevProps) {
        if (prevProps.searchValue != this.props.searchValue) {
            this.search(this.props.searchValue);
        }
    };
    /**
     * 获取树的基础展示外观参数
    */
    BaseTree.prototype.getFace = function () {
        var _this = this;
        // 核对参数
        var param = { showLine: true, };
        if (this.props.className) {
            param.className = 'utree ' + this.props.className;
        }
        else {
            param.className = 'utree';
        }
        param.style = this.props.style;
        param.selectable = true;
        param.multiple = false;
        if (!_.has(this.props, 'onSelect') || this.props.onSelect == null) {
            param.selectable = false;
        }
        else {
            param.selectedKeys = this.state.selectedKeys;
        }
        if (this.props.defaultExpandAll) {
            param.defaultExpandAll = true;
        }
        if (this.props.defaultExpandedKeys && _.isArray(this.props.defaultExpandedKeys)) {
            param.defaultExpandedKeys = this.props.defaultExpandedKeys;
        }
        if (this.props.disabled) {
            param.selectable = false;
            param.disabled = true;
        }
        if (param.selectable) {
            param.onSelect = function (keys, evt) { return _this.onSelect(keys, evt); };
        }
        if (this.props.iconField) {
            param.showIcon = true;
        }
        else {
            param.showIcon = false;
        }
        return param;
    };
    // 高性能树递归搜索
    BaseTree.prototype.search = function (keyword) {
        var _this = this;
        var word = _.trim(keyword);
        if (word == '' || word == null) {
            this.setState({ searchPos: null, keyword: null });
            return;
        }
        var SearchResult = [];
        this.state.tree.map(function (node, idx) { return _this.searchNode(node, [idx], _.toLower(word), SearchResult); });
        var searchPos = new Set();
        SearchResult.map(function (pos) {
            var key = pos;
            searchPos.add(key);
            var idx = key.lastIndexOf('-');
            while (idx > 0) {
                key = key.substring(0, idx);
                idx = key.lastIndexOf('-');
                searchPos.add(key);
            }
        });
        this.setState({ searchPos: searchPos, keyword: word });
    };
    BaseTree.prototype.searchNode = function (node, pos, word, result) {
        var titleField = this.fields.titleField;
        var name = _.toLower(node[titleField]);
        if (name.indexOf(word) >= 0) {
            result.push(pos.join('-'));
        }
        if (node.children && node.children.length) {
            this.searchNodes(node.children, pos, word, result);
        }
    };
    BaseTree.prototype.searchNodes = function (data, pos, word, result) {
        var _this = this;
        return data.map(function (item, idx) { return _this.searchNode(item, __spreadArray(__spreadArray([], __read(pos), false), [idx], false), word, result); });
    };
    BaseTree.prototype.renderTitle = function (node, title, keyword, idx, len, pos) {
        return keyword ? (0, HighLight_1.highLight)(title, keyword) : title;
    };
    BaseTree.prototype.getNodeParam = function (node, keyword, pos, len, position) {
        var _a = this.fields, titleField = _a.titleField, keyField = _a.keyField, iconField = _a.iconField;
        var param = {
            key: node[keyField] + '',
            title: this.renderTitle(node, node[titleField], keyword, pos[pos.length - 1], len, pos),
            pos: position,
        };
        if (iconField) {
            if (_.isString(iconField)) {
                if (node[iconField] && node[iconField].indexOf('/') >= 0) {
                    param.icon = React.createElement("span", { style: { lineHeight: '24px' } },
                        React.createElement("img", { style: { marginTop: -4 }, src: node[iconField] }));
                }
                else {
                    param.icon = React.createElement(antd_1.Icon, { type: node[iconField] });
                }
            }
            else if (_.isFunction(iconField)) {
                var icon = iconField(node);
                if (icon) {
                    param.icon = icon;
                }
            }
        }
        return param;
    };
    BaseTree.prototype.renderNode = function (node, pos, len) {
        var position = pos.join('-');
        var _a = this.state, keyword = _a.keyword, searchPos = _a.searchPos;
        if (keyword) {
            if (!searchPos.has(position)) {
                return React.createElement(React.Fragment, null);
            }
        }
        var param = this.getNodeParam(node, keyword, pos, len, position);
        if (_.isArray(node.children) && node.children.length) {
            return React.createElement(antd_1.Tree.TreeNode, __assign({ dataRef: node }, param), this.renderNodes(node.children, pos));
        }
        return React.createElement(antd_1.Tree.TreeNode, __assign({ dataRef: node }, param));
    };
    BaseTree.prototype.renderNodes = function (data, pos) {
        var _this = this;
        return data.map(function (item, idx) { return _this.renderNode(item, __spreadArray(__spreadArray([], __read(pos), false), [idx], false), data.length); });
    };
    BaseTree.prototype.renderRoot = function (data) {
        var _this = this;
        if (this.state.keyword && this.state.searchPos.size == 0) {
            return React.createElement(antd_1.Tree.TreeNode, { title: React.createElement(antd_1.Empty, { description: React.createElement(React.Fragment, null,
                        "\u6CA1\u6709\u627E\u5230 ",
                        React.createElement("b", null, this.state.keyword),
                        " \u76F8\u5E94\u7684\u6570\u636E") }), selectable: false, className: "utree-empty" });
        }
        return data.map(function (node, idx) { return _this.renderNode(node, [idx], data.length); });
    };
    return BaseTree;
}(React.Component));
exports.BaseTree = BaseTree;
