"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var antd_1 = require("antd");
var VForm_1 = require("./VForm");
var _ = require("lodash");
var formatFields = function (str) { return str.toString().replace(/，/g, ',').replace(/\s/g, '').replace(/,{2,}/g, ','); };
var tabMap = new Map();
var VFormModal = /** @class */ (function (_super) {
    __extends(VFormModal, _super);
    function VFormModal() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            tabKey: '',
            isClose: false,
        };
        _this.formRef = null;
        _this.onSubmit = function (e) { return __awaiter(_this, void 0, void 0, function () {
            var values;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.formRef.onSubmit(e)];
                    case 1:
                        values = _a.sent();
                        if (values) {
                            this.props.onOk && this.props.onOk(values);
                        }
                        return [2 /*return*/];
                }
            });
        }); };
        _this.setTabColumn = function () {
            if (_.has(_this.props, 'tabs')) {
                var allFieldList_1 = [];
                _.map(_this.props.tabs, function (tab) {
                    var currentFieldList = formatFields(tab.fields).split(',');
                    allFieldList_1 = _.concat([], allFieldList_1, currentFieldList);
                    var currentColumns = _.filter(_this.props.columns, function (c) { return _.includes(currentFieldList, c.field); });
                    tabMap.set(tab.key, currentColumns);
                });
                var otherColumns = _.filter(_this.props.columns, function (c) { return !_.includes(allFieldList_1, c.field); });
                if (!_.isEmpty(otherColumns)) {
                    tabMap.set('other_key', otherColumns);
                }
                _this.setState({ tabKey: _this.props.tabs[0].key });
            }
        };
        return _this;
    }
    VFormModal.prototype.componentDidMount = function () {
        this.setTabColumn();
    };
    VFormModal.prototype.render = function () {
        var _this = this;
        var hasGroup = _.has(this.props, 'group');
        var foldIcon = _.get(this.props, 'foldIcon');
        var groupCloseIcon = null;
        var title = this.props.title || null;
        var extraParam = hasGroup ? { isClose: this.state.isClose } : {};
        //折起不为null，构造折起元素和title元素
        if (foldIcon !== null) {
            groupCloseIcon = hasGroup ? React.createElement("span", { onClick: function () { return _this.setState({ isClose: !_this.state.isClose }); }, className: 'vform-isclose' }, this.state.isClose ? ((foldIcon && foldIcon[1]) || React.createElement(React.Fragment, null,
                "\u5168\u90E8\u6536\u8D77 ",
                React.createElement(antd_1.Icon, { type: 'right' }))) : ((foldIcon && foldIcon[0]) || React.createElement(React.Fragment, null,
                "\u5168\u90E8\u5C55\u5F00 ",
                React.createElement(antd_1.Icon, { type: 'down' })))) : null;
            title = hasGroup ? React.createElement(React.Fragment, null,
                title,
                groupCloseIcon) : title;
        }
        if (_.has(this.props, 'tabs')) {
            title = React.createElement(antd_1.Tabs, { activeKey: this.state.tabKey, tabBarExtraContent: groupCloseIcon, onChange: function (tabKey) { return _this.setState({ tabKey: tabKey }); } }, this.props.tabs.map(function (tab, i) { return React.createElement(antd_1.Tabs.TabPane, { tab: tab.title, key: tab.key }); }));
        }
        var bodyStyle = this.props.layout == 'table' ? { padding: '0 1px' } : {};
        return React.createElement(antd_1.Modal, __assign({ destroyOnClose: true, maskClosable: window.VAP_GLOBAL.UFORM.maskClosable }, this.props, { bodyStyle: __assign(__assign({}, bodyStyle), (this.props.bodyStyle || {})), title: title, onOk: this.onSubmit }),
            React.createElement(VForm_1.default, __assign({}, this.props, extraParam, { onOk: null, onCancel: null, columns: _.has(this.props, 'tabs') ? tabMap.get(this.state.tabKey) : this.props.columns, footer: function () { return null; }, wrappedComponentRef: function (f) {
                    _this.formRef = f;
                    _this.props.formRef && _this.props.formRef(f);
                } })));
    };
    return VFormModal;
}(React.PureComponent));
exports.default = VFormModal;
