"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var antd_1 = require("antd");
var _ = require("lodash");
//增量key
var addkey = (function (key) {
    if (key === void 0) { key = 1; }
    return function () { return key++; };
})();
//去掉key，用于新增
var removeKey = function (obj, key) {
    var e_1, _a;
    var _obj = {};
    try {
        for (var _b = __values(Object.getOwnPropertyNames(obj)), _c = _b.next(); !_c.done; _c = _b.next()) {
            var item = _c.value;
            if (item !== key) {
                _obj[item] = obj[item];
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return _obj;
};
//可编辑表格
var EditTable = /** @class */ (function (_super) {
    __extends(EditTable, _super);
    function EditTable() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            data: [],
            record: {},
            emptyRecord: {},
            errorMap: new Map(), //存储出错的列，key为dataIndex, value为message
        };
        //构造带rowkey的空行，用于新增
        _this.getEmptyRecord = function () {
            var emptyRecord = {};
            emptyRecord[_this.props.rowKey] = '_add_key_' + addkey();
            _this.props.columns.forEach(function (column) {
                emptyRecord[column.dataIndex] = '';
                if (column.dataIndex) {
                    _this.changeInput(emptyRecord[column.dataIndex], column, {});
                }
            });
            return emptyRecord;
        };
        //更改input值，判断rule {required?, message?, validator?, pattern?}
        _this.changeInput = function (val, column, record) {
            var e_2, _a, _b;
            var rules = _.get(column, 'rule');
            var errorMap = _this.state.errorMap;
            if (_.isArray(rules) && !_.isEmpty(rules)) {
                try {
                    for (var rules_1 = __values(rules), rules_1_1 = rules_1.next(); !rules_1_1.done; rules_1_1 = rules_1.next()) {
                        var rule = rules_1_1.value;
                        if (_.isFunction(rule.validator)) {
                            if (!rule.validator(val)) {
                                errorMap.set(column.dataIndex, _.get(rule, 'message') || "".concat(column.title, "\u8F93\u5165\u5185\u5BB9\u6709\u8BEF"));
                                break;
                            }
                            else {
                                errorMap.delete(column.dataIndex);
                            }
                        }
                        else if (_.isRegExp(rule.pattern)) {
                            if (!rule.pattern.test(val)) {
                                errorMap.set(column.dataIndex, _.get(rule, 'message') || "".concat(column.title, "\u8F93\u5165\u5185\u5BB9\u6709\u8BEF"));
                                break;
                            }
                            else {
                                errorMap.delete(column.dataIndex);
                            }
                        }
                        else if (_.has(rule, 'required')) {
                            if (!val || _.isNil(val) || _.isEmpty(val)) {
                                errorMap.set(column.dataIndex, _.get(rule, 'message') || "".concat(column.title, "\u5FC5\u586B"));
                                break;
                            }
                            else {
                                errorMap.delete(column.dataIndex);
                            }
                        }
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (rules_1_1 && !rules_1_1.done && (_a = rules_1.return)) _a.call(rules_1);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
            }
            _this.setState({ errorMap: errorMap, record: __assign(__assign({}, record), (_b = {}, _b[column.dataIndex] = val, _b)) });
        };
        return _this;
    }
    EditTable.prototype.componentDidMount = function () {
        this.setState({ data: this.props.dataSource });
    };
    EditTable.prototype.componentDidUpdate = function (prevProps, prevState) {
        if (!_.isEqual(prevProps.dataSource, this.props.dataSource)) {
            this.setState({ data: this.props.dataSource, record: {} });
        }
    };
    EditTable.prototype.render = function () {
        var _this = this;
        var _a = this.props, columns = _a.columns, rowKey = _a.rowKey, onChange = _a.onChange, disabled = _a.disabled, onRowClick = _a.onRowClick, onAddClick = _a.onAddClick, onDeleteClick = _a.onDeleteClick, rest = __rest(_a, ["columns", "rowKey", "onChange", "disabled", "onRowClick", "onAddClick", "onDeleteClick"]);
        var _b = this.state, data = _b.data, record = _b.record, emptyRecord = _b.emptyRecord;
        data = _.isEmpty(emptyRecord) ? data : _.concat([], data, emptyRecord);
        return React.createElement("div", { className: 'edittable' },
            React.createElement(antd_1.Table, __assign({ size: "small" }, rest, { pagination: false, className: ' vap-table vap-table-inner ' + (this.props.className || ''), dataSource: data, columns: _.concat(_.map(columns, function (d) {
                    var _d = _.extend({}, d);
                    _d['originRender'] = _.has(_d, 'render') ? _d.render : (function (v) { return v; });
                    _d['render'] = function (t, r, i) {
                        return (r[rowKey] === _.get(record, rowKey) && (!_.has(_d, 'disabled') || _d.disabled === false)) ?
                            React.createElement(antd_1.Input, { size: 'small', defaultValue: t, placeholder: _.get(_d, 'placeholder') || '', onChange: function (e) { return _this.changeInput(e.target.value, _d, record); } })
                            : _d.originRender(t, r, i);
                    };
                    return _d;
                }), {
                    title: '操作', dataIndex: '', align: 'center', width: 80, className: 'table-actions', render: function (t, r, i) {
                        var operDisabled = !_.isEmpty(record);
                        return (!_.isEmpty(record) && r[rowKey] === _.get(record, rowKey)) ? [
                            React.createElement(antd_1.Button, { type: 'link', size: 'small', onClick: function () {
                                    var _a;
                                    if (!_.isEmpty(_this.state.errorMap)) {
                                        antd_1.message.warning('输入有误：' + __spreadArray([], __read(_this.state.errorMap.values()), false).join(', '));
                                        return;
                                    }
                                    var index = _.findIndex(data, (_a = {}, _a[rowKey] = r[rowKey], _a));
                                    data.splice(index, 1, record);
                                    var param = _.startsWith(r[rowKey], '_add_key_') ? { method: 'add', data: removeKey(record, rowKey) } : { method: 'patch', data: record };
                                    onChange(data, param);
                                    _this.setState({ data: data, record: {}, emptyRecord: {} });
                                } }, "\u4FDD\u5B58"),
                            React.createElement(antd_1.Button, { type: 'link', size: 'small', onClick: function () { return _this.setState({ record: {}, emptyRecord: {}, errorMap: new Map() }); } }, "\u53D6\u6D88"),
                        ] : [
                            React.createElement(antd_1.Button, { type: 'link', size: 'small', disabled: operDisabled || disabled, onClick: function () {
                                    onRowClick ? onRowClick(r, i, _this.props.dataSource) : _this.setState({ record: r, emptyRecord: {} });
                                } }, "\u4FEE\u6539"),
                            React.createElement(antd_1.Popconfirm, { title: '\u786E\u8BA4\u5220\u9664\u5417\uFF1F', disabled: operDisabled || disabled, onConfirm: function () {
                                    var _a;
                                    if (onDeleteClick) {
                                        onDeleteClick(r, i, _this.props.dataSource);
                                    }
                                    else {
                                        var index = _.findIndex(data, (_a = {}, _a[rowKey] = r[rowKey], _a));
                                        data.splice(index, 1);
                                        var param = { method: 'delete', data: r };
                                        onChange(data, param);
                                        _this.setState({ data: data, record: {}, emptyRecord: {} });
                                    }
                                } },
                                React.createElement(antd_1.Button, { type: 'link', size: 'small', disabled: operDisabled }, "\u5220\u9664"))
                        ];
                    }
                }) })),
            React.createElement("div", { className: 'edittable-add' },
                React.createElement(antd_1.Button, { icon: 'plus', style: { width: '100%' }, disabled: !_.isEmpty(this.state.record) || disabled, onClick: function () {
                        if (onAddClick) {
                            onAddClick(_this.props.dataSource);
                        }
                        else {
                            var emptyRecord_1 = _this.getEmptyRecord();
                            _this.setState({ emptyRecord: emptyRecord_1, record: emptyRecord_1 });
                        }
                    } }, "\u65B0\u589E")));
    };
    return EditTable;
}(React.PureComponent));
exports.default = EditTable;
