import * as React from 'react';
export interface EditTagProps {
    /**
     * 传入的对象数组,vform中无需传入，对象中_color字段表示Tag的color颜色
     */
    data?: any[];
    /**
     * 展示函数
     */
    renderItem?: (item?: any, i?: any) => React.ReactNode;
    /**
     * 是否可删除
     */
    closable?: boolean;
    /**
     * 是否可添加，string表示button按钮标题，false表示不可添加，节点表示自定义添加元素
     */
    addButton?: React.ReactNode;
    /**
     * 删除或添加事件是否禁用
     */
    disabled?: boolean;
    /**
     * 删除事件，由上级调用
     */
    onDeleteClick?: (item?: any, i?: any, data?: any) => any;
    /**
     * 点击事件，由上级调用
     */
    onRowClick?: (item?: any, i?: any, data?: any) => any;
    /**
     * 添加事件，由上级调用，不传则默认在末尾加一个Input
     */
    onAddClick?: (data?: any) => any;
    /**
     * 其他
     */
    [propName: string]: any;
}
export default class EditTag extends React.PureComponent<EditTagProps> {
    render(): JSX.Element;
}
