"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
exports.default = {
    /**
     * basePage 可创建一个基础页面的 state Hook
    */
    basePage: function (namespace, dispatch) {
        var _a = __read((0, react_1.useState)({ showForm: false, isEdit: false, editObject: null, showImport: false }), 2), state = _a[0], setState = _a[1];
        var showAdd = function () { return setState({ showForm: true, isEdit: false, editObject: null, showImport: false }); };
        var showInfo = function (editObject) { return setState({ showForm: true, isEdit: false, editObject: editObject, showImport: false }); };
        var showEdit = function (editObject) { return setState({ showForm: true, isEdit: true, editObject: editObject, showImport: false }); };
        var hide = function () { return setState({ showImport: false, showForm: false, isEdit: false, editObject: state.editObject }); };
        var showImportModal = function () { return setState({ showImport: true, showForm: false, isEdit: false, editObject: state.editObject, }); };
        var hideImportModal = function () { return setState({ showImport: false, showForm: false, isEdit: false, editObject: state.editObject, }); };
        var onOk = function (data) {
            hide();
            if (state.isEdit) {
                dispatch({ type: "".concat(namespace, "/_edit"), data: data });
            }
            else {
                dispatch({ type: "".concat(namespace, "/_add"), data: data });
            }
        };
        var add = function (data) {
            hide();
            dispatch({ type: "".concat(namespace, "/_add"), data: data });
        };
        var update = function (data) {
            hide();
            dispatch({ type: "".concat(namespace, "/_edit"), data: data });
        };
        var del = function (data) { return dispatch({ type: "".concat(namespace, "/_delete"), data: data }); };
        return {
            state: state,
            /**
             * 显示添加弹框
            */
            showAdd: showAdd,
            /**
             * 显示编辑弹框
             * @param editObject 需要编辑的对象
            */
            showEdit: showEdit,
            /**
             * 显示详情弹框
             * @param editObject 需要编辑的对象
            */
            showInfo: showInfo,
            /**
             * 显示详情弹框
             * @param data 需要删除的对象 ,可以为一个数组(删除多个)，可以为一个对象(删除一个)，也可以是一个字符串(删除一个，以此为id)
            */
            del: del,
            /**
             * 添加
             * @param data 需要添加的对象，使用 onOk 可以自动判断
            */
            add: add,
            /**
             * 修改
             * @param data 需要修改的对象，使用 onOk 可以自动判断
            */
            update: update,
            /**
             * 隐藏弹框
            */
            hide: hide,
            /**
             * 自动添加或修改
             * @param data 需要添加或修改的对象
            */
            onOk: onOk,
            /**
             * 显示导入弹框
            */
            showImportModal: showImportModal,
            /**
             * 隐藏导入弹框
            */
            hideImportModal: hideImportModal
        };
    }
};
