/// <reference types="react" />
import { RowProps } from 'antd/lib/row';
import { CardProps } from 'antd/lib/card';
export interface VRowProps extends RowProps {
    height?: number | string;
}
/**
 * @deprecated
 * 说明 : 由于技术原因 以下组件即将失效
 *  VRow/VCol/VRowCol/VHeader
 * 建议方案 : 使用更新更强大更美观的 布局方案 ： import { VRow, VCOl, VRowCol} from  'vap/layout';
 *  如果没有用到某些特殊功能，基本上是兼容
 *  VRow/VCOl/VRowCol/Grids
*/
export interface VRowColProps {
    className?: string;
    height?: number | string;
    colStyle?: React.CSSProperties;
    cardStyle?: React.CSSProperties;
    style?: React.CSSProperties;
    title?: React.ReactNode;
    icon?: string;
    /**
     * 如果传loading ，则根据 loading true/false / 显示 加载状态
    */
    loading?: boolean;
    /**
     * dva 对象里面的的 effect 如果定义此值，当在 执行时，显示一个loading图标
    */
    loading_effect?: string;
    /**
     * 显示 加载状态，距上边距
    */
    loading_top?: number;
    headStyle?: React.CSSProperties;
    bodyStyle?: React.CSSProperties;
}
export interface VColProps extends CardProps {
    /**
     * Panel 的标题
    */
    title?: React.ReactNode;
    /**
     * Panel 标题前面的ICON
    */
    icon?: string;
    /**
     * 为便于排版，
     * 默认为透明，如果需要
    */
    bg?: boolean;
    /**
     * 如果传loading ，则根据 loading true/false / 显示 加载状态
    */
    loading?: boolean;
    /**
     * dva 对象里面的的 effect 如果定义此值，当在 执行时，显示一个loading图标
    */
    loading_effect?: string;
    /**
     * 显示 加载状态，距上边距
    */
    loading_top?: number;
    /**
     * 对应  antd <Col> 的 Style
    */
    colStyle?: React.CSSProperties;
    bordered?: boolean;
    span?: number;
    xs?: number;
    sm?: number;
    md?: number;
    lg?: number;
    xl?: number;
    xxl?: number;
}
export interface VHeaderProps {
    className?: string;
    style?: React.CSSProperties;
}
