import * as React from 'react';
export interface TreeData {
    [propName: string]: any;
    children?: TreeData[];
}
export interface TreePanelOpts {
    /**
     * 树的标题，可以传入自定义的 ReactNode
    */
    title: React.ReactNode;
    /**
     * 树使用的数据， 是一个对象数组
    */
    data: TreeData[];
    /**
     * 树显示名称的字段 ，默认为 `name`
    */
    nameField?: string;
    /**
     * 树取值的字段，默认为 `value`
    */
    valueField?: string;
    /**
     * 树显示Icon字段 ，默认为空，传入后，以此字段显示图标
    */
    iconField?: string;
    /**
     * 选中后的回调函数
    */
    onSelect: Function;
    /**
     * 是否必须选择一项？
    */
    mustSelect?: boolean;
    /**
     * 默认选择
    */
    defaultSelect?: string | number;
    /**
     * 说明：设置loadData方法后，将会变成动态树！
    */
    loadData?: (key: string) => Promise<any>;
    /**
     * 是否默认展开全部
    */
    defaultExpandAll?: boolean;
}
