"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var _ = require("lodash");
var antd_1 = require("antd");
var utils_1 = require("../../utils");
var dva_1 = require("dva");
var SearchBar_1 = require("../../_common/Table/SearchBar");
var SelectBar_1 = require("../../_common/Table/SelectBar");
var SearchKeyWord_1 = require("../../_common/Table/SearchKeyWord");
var UPagination_1 = require("../../_common/UPagination");
var DragSort_1 = require("../../_common/DragSort");
var ACTIONS_1 = require("../../_common/Table/ACTIONS");
var HighLight_1 = require("../../utils/HighLight");
var MIN_HEIGHT = 694;
/**
 * VTable ： 数据Table组件, 说明 DataTable 和 TableLayout 不再支持，请使用VTable 替代
*/
var VTable = /** @class */ (function (_super) {
    __extends(VTable, _super);
    function VTable(props) {
        var _this = _super.call(this, props) || this;
        _this.mode = 'common';
        _this.id = 'id_' + _.random(99999999);
        _this.rowKey = 'id';
        _this.fetch = '';
        _this.param = {};
        _this.columns = [];
        _this.initColumns = []; //完整的columns，用于隐藏列恢复
        _this.state = {
            showCustom: false,
            selectedRowKeys: [],
            selectObjects: [],
            current: 1,
            pageSize: _.get(_this.props.pagination, 'defaultPageSize') || window.VAP_GLOBAL.PAGINATION.SIZE_DEFAULT,
            maxHeight: MIN_HEIGHT,
            customTemp: {} //临时列，往columnCache读取或写入数据
        };
        //弹窗中临时列信息变化
        _this.changeColumnsTemp = function (columns) {
            var customColumn = {};
            columns.map(function (item, sort) {
                if (item.dataIndex) {
                    customColumn[item.dataIndex] = { show: _.has(item, 'show') ? item.show : true, sort: sort, title: item.title, dataIndex: item.dataIndex, key: _.has(item, 'key') ? item.key : sort };
                }
            });
            _this.setState({ customTemp: customColumn });
        };
        //弹窗中列展示开关变化
        _this.changeColumnShow = function (checked, column) {
            var customTemp = _.extend({}, _this.state.customTemp);
            if (_.has(customTemp, column.dataIndex)) {
                customTemp[column.dataIndex].show = checked;
            }
            _this.setState({ customTemp: customTemp });
        };
        //列展示和排序，缓存临时列信息到本地cache
        _this.showColumns = function (columnCache) {
            _this.columns = _.filter(_this.initColumns, function (item) {
                if (!_.has(columnCache, item.dataIndex)) {
                    return true;
                }
                if (!_.has(columnCache[item.dataIndex], 'show')) {
                    return true;
                }
                return columnCache[item.dataIndex].show;
            });
            _this.columns = _.sortBy(_this.columns, function (item) {
                if (_.has(columnCache, item.dataIndex)) {
                    return columnCache[item.dataIndex].sort;
                }
                else if (_.has(item, 'className') && item.className == '_index') {
                    return -1;
                }
                else {
                    return 999;
                }
            });
            utils_1.Cache.sessionData(_this.props.columnCache, columnCache);
        };
        /**
         * 获取选中项
         */
        _this.getSelected = function () { return [_this.state.selectedRowKeys, _this.state.selectObjects]; };
        /**
         * 映射方法，手动设置选中项
        */
        _this.setSelected = function (keys) {
            var VLIST = window.VAP_GLOBAL.VLIST;
            var selectedRowKeys = [];
            var selectObjects = [];
            var dataSource = _.has(_this.props, 'dataSource') ? _this.props.dataSource : _this.props[_this.props.namespace][VLIST.list];
            if (_.isArray(keys)) {
                keys.map(function (key) {
                    var obj = _.find(dataSource, function (item) { return item[_this.rowKey] == key; });
                    if (obj) {
                        selectedRowKeys.push(obj[_this.rowKey]);
                        selectObjects.push(obj);
                    }
                });
            }
            else {
                var obj = _.find(dataSource, function (item) { return item[_this.rowKey] == keys; });
                if (obj) {
                    selectedRowKeys.push(obj[_this.rowKey]);
                    selectObjects.push(obj);
                }
            }
            _this.setState({ selectedRowKeys: selectedRowKeys, selectObjects: selectObjects });
        };
        /**
         * 获取当前查询参数
         */
        _this.getParam = function () { return _this.param; };
        /**
         * 查询
         *  */
        _this.query = function (param, manaul) {
            var _a;
            if (manaul === void 0) { manaul = false; }
            var VLIST = window.VAP_GLOBAL.VLIST;
            _.extend(_this.param, param, (_a = {}, _a[VLIST.start] = 0, _a[VLIST.count] = _this.state.pageSize, _a));
            _.keys(_this.param).map(function (key) {
                if (_.isString(_this.param[key]) && _this.param[key] == '') {
                    _.unset(_this.param, key);
                }
            });
            _this.setState({ current: 1, selectedRowKeys: [], selectedRows: [], });
            if (manaul) {
                _this.fetchData(_.extend({}, _this.props.default, _this.param));
                utils_1.Ajax.POST('/api-serversys/syslog/addSysLog', { type: 1, requestUrl: window.location.pathname + window.location.hash });
            }
            else {
                _this.fetchData(_.extend({}, _this.props.default, _this.param));
            }
        };
        /**
         * 刷新当前页面
         *  */
        _this.reflush = function (param) {
            var _a;
            if (param === void 0) { param = {}; }
            var VLIST = window.VAP_GLOBAL.VLIST;
            _this.query(_.extend(_this.param, (_a = {}, _a[VLIST.start] = 0, _a), param));
        };
        if (!_.has(_this.props, 'namespace')) {
            if (!_.has(_this.props, 'fetch') || !_.has(_this.props, 'total') || !_.has(_this.props, 'dataSource')) {
                console.error('参数 namespace 或 fetch/total/dataSource 缺失');
            }
        }
        else {
            if (_.has(_this.props[_this.props.namespace], '_rowKey')) {
                _this.rowKey = _this.props[_this.props.namespace]._rowKey;
            }
        }
        if (_.has(_this.props, 'rowKey')) {
            _this.rowKey = _this.props.rowKey;
        }
        _this.fetch = _this.props.fetch ? _this.props.fetch : (_this.props.namespace + '/_query');
        if (_.has(_this.props, 'keyword.highlight')) {
            //@ts-ignore
            var highlight = _this.props.keyword.highlight;
            var keys_1 = new Set();
            highlight.map(function (item) { return keys_1.add(item); });
            _this.props.columns.map(function (item) {
                if (keys_1.has(item.dataIndex) && (item.render == null || item.render == undefined)) {
                    item.render = function (text) {
                        return (0, HighLight_1.highLight)(text, _this.param.keyword_);
                    };
                }
            });
        }
        _this.columns = _.concat([], _.filter(_this.props.columns, function (item) { return item.show === undefined || item.show == true; }));
        _this.initColumns = _.concat([], _.filter(_this.props.columns, function (item) { return item.show === undefined || item.show == true; }));
        if (_.has(_this.props, 'mode')) {
            _this.mode = _this.props.mode;
        }
        if (_.has(_this.props, 'columnCache')) {
            var columnCache = utils_1.Cache.sessionData(_this.props.columnCache);
            if (columnCache) {
                _this.showColumns(columnCache);
            }
            else {
                var columnCache_1 = {};
                _this.props.columns.map(function (item, sort) {
                    if (item.dataIndex) {
                        columnCache_1[item.dataIndex] = { show: item.show || true, sort: sort, title: item.title, dataIndex: item.dataIndex, key: _.has(item, 'key') ? item.key : sort };
                    }
                });
                utils_1.Cache.sessionData(_this.props.columnCache, columnCache_1);
            }
        }
        if (_this.props.showIndex !== false) {
            if (_this.props.showIndex === undefined) {
                var _indexItem = {
                    // title: <span>序号</span>,
                    title: React.createElement("span", null,
                        "\u5E8F\u53F7 ",
                        _this.props.columnCache && React.createElement("a", { title: '\u81EA\u5B9A\u4E49\u5217\u987A\u5E8F', onClick: function () {
                                var customTemp = utils_1.Cache.sessionData(_this.props.columnCache);
                                _this.setState({ showCustom: true, customTemp: customTemp });
                            } },
                            React.createElement(antd_1.Icon, { type: "align-left" }))),
                    className: '_index',
                    render: function (d, j, i) { return i + (_this.state.current - 1) * _this.state.pageSize + 1; }
                };
                _this.columns.unshift(_indexItem);
                _this.initColumns.unshift(_indexItem);
            }
            else if (_.isString(_this.props.showIndex)) {
                var _indexItem = {
                    // title: <span>{this.props.showIndex}</span>,
                    title: React.createElement("span", null,
                        _this.props.showIndex,
                        " ",
                        _this.props.columnCache && React.createElement(antd_1.Icon, { type: "align-left", onClick: function () {
                                var customTemp = utils_1.Cache.sessionData(_this.props.columnCache);
                                _this.setState({ showCustom: true, customTemp: customTemp });
                            } })),
                    // title: ,
                    className: '_index',
                    render: function (d, j, i) { return i + (_this.state.current - 1) * _this.state.pageSize + 1; }
                };
                _this.columns.unshift(_indexItem);
                _this.initColumns.unshift(_indexItem);
            }
        }
        _.extend(_this.param, _this.props.default);
        return _this;
    }
    VTable.prototype.fetchData = function (param, callback, total_) {
        if (callback === void 0) { callback = undefined; }
        if (total_ === void 0) { total_ = true; }
        var query = param;
        if (this.props.beforeSearch) {
            query = this.props.beforeSearch(query);
            if (query === null || query === false) {
                return;
            }
        }
        // @ts-ignore
        this.props.dispatch(_.extend({ type: this.fetch }, { query: query, total_: total_ }, { callback: callback }));
    };
    VTable.prototype.componentDidMount = function () {
        var _a;
        if (this.props.autoLoad === false) {
            return;
        }
        var VLIST = window.VAP_GLOBAL.VLIST;
        this.fetchData(_.extend(this.param, (_a = {}, _a[VLIST.start] = 0, _a[VLIST.count] = this.state.pageSize, _a)));
        this.reMax();
    };
    VTable.prototype.componentWillUnmount = function () {
        utils_1.Cache.sessionDelete(this.props.columnCache);
    };
    //重新设置表格的列，及序号设置，序号不传则为原序号
    VTable.prototype.setColumns = function (columns, showIndex) {
        var _this = this;
        if (showIndex === void 0) { showIndex = null; }
        this.columns = _.concat([], _.filter(columns, function (item) { return item.show === undefined || item.show == true; }));
        var index = this.props.showIndex;
        if (showIndex !== null) {
            index = showIndex;
        }
        if (index !== false) {
            if (index === undefined || index === true) {
                this.columns.unshift({
                    title: '序号',
                    className: '_index',
                    render: function (d, j, i) { return i + (_this.state.current - 1) * _this.state.pageSize + 1; }
                });
            }
            else if (_.isString(index)) {
                this.columns.unshift({
                    title: index,
                    className: '_index',
                    render: function (d, j, i) { return i + (_this.state.current - 1) * _this.state.pageSize + 1; }
                });
            }
        }
        this.param = _.extend({}, this.props.default);
        this.setState({ _t: _.now() });
    };
    VTable.prototype.onSelect = function (selectedRowKeys, selectObjects) {
        var _this = this;
        this.setState({ selectedRowKeys: selectedRowKeys, selectObjects: selectObjects }, function () {
            if (_this.props.onSelectedChange) {
                _this.props.onSelectedChange(selectedRowKeys, selectObjects);
            }
        });
    };
    VTable.prototype.renderSelectBar = function () {
        var _this = this;
        if (!_.has(this.props, 'selectBar')) {
            return React.createElement(React.Fragment, null);
        }
        var style = {};
        if (this.mode == 'common') {
            style.maxHeight = this.state.maxHeight;
        }
        else {
            style.maxHeight = '100%';
        }
        return React.createElement(SelectBar_1.default, __assign({}, this.props.selectBar, { style: style, onSelect: function (key, obj, parent) {
                var result = _this.props.selectBar.onSelect(key, obj, parent);
                if (_.isPlainObject(result)) {
                    _this.query(result);
                }
            } }));
    };
    VTable.prototype.reMax = function () {
        if (this.props.selectBar || this.mode != 'common') {
            var layout = document.getElementById(this.id);
            var height = 0;
            var searchBar = layout.getElementsByClassName('vap-table-search-bar');
            var table = layout.getElementsByClassName('ant-table-wrapper');
            var page = layout.getElementsByClassName('upagination');
            if (searchBar.length == 1) {
                // @ts-ignore
                height += searchBar[0].offsetHeight;
            }
            if (searchBar.length == 1) {
                // @ts-ignore
                height += table[0].offsetHeight;
            }
            if (page.length == 1) {
                // @ts-ignore
                height += page[0].offsetHeight;
            }
            if (height <= MIN_HEIGHT) {
                height = MIN_HEIGHT;
            }
            this.setState({ maxHeight: height });
        }
    };
    VTable.prototype.renderSearchBar = function () {
        var _this = this;
        if (!_.has(this.props, 'searchBar')) {
            return React.createElement(React.Fragment, null);
        }
        var VLIST = window.VAP_GLOBAL.VLIST;
        var dataSource = _.has(this.props, 'dataSource') ? this.props.dataSource : this.props[this.props.namespace][VLIST.list];
        var selectedRowKeys = _.intersection(this.state.selectedRowKeys, (dataSource || []).map(function (item) { return item[_this.rowKey]; }));
        if (_.has(this.props, 'keyword')) {
            return React.createElement(SearchKeyWord_1.default, __assign({ keyword: this.props.keyword, onSearch: function (param) {
                    if (param.keyword_ && _.trim(param.keyword_).length > 0) {
                        _this.query(_.assign({}, _this.props.default, param), true);
                    }
                    else {
                        _.keys(param).map(function (key) {
                            if (param[key] == '' && _.has(_this.param, key)) {
                                _.unset(_this.param, key);
                            }
                        });
                        _this.query(param, true);
                    }
                }, onChange: function (param) { return _.extend(_this.param, param); }, default: this.props.default }, this.props.searchBar, { selectedRowKeys: selectedRowKeys, selectObjects: this.state.selectObjects, param: this.param }));
        }
        return React.createElement(SearchBar_1.default, __assign({ onSearch: function (param) {
                _.keys(param).map(function (key) {
                    if (param[key] == '' && _.has(_this.param, key)) {
                        _.unset(_this.param, key);
                    }
                });
                _this.query(param, true);
            }, onChange: function (param) { return _.extend(_this.param, param); }, default: this.props.default }, this.props.searchBar, { selectedRowKeys: selectedRowKeys, selectObjects: this.state.selectObjects, onExpands: function () { return _this.reMax(); }, param: this.param }));
    };
    VTable.prototype.sorterField = function (sorter) {
        var _a;
        var VLIST = window.VAP_GLOBAL.VLIST;
        var query = (_a = {},
            _a[VLIST.start] = 0,
            _a[VLIST.count] = this.state.pageSize,
            _a);
        this.setState({ selectedRowKeys: [], selectObjects: [], current: 1, });
        if (_.has(sorter, 'field')) {
            query[VLIST.order] = sorter.field;
            query[VLIST.by] = sorter.order == 'ascend' ? 'asc' : 'desc';
        }
        _.extend(this.param, query);
        if (!_.has(sorter, 'order')) {
            _.unset(this.param, VLIST.order);
            _.unset(this.param, VLIST.by);
        }
        this.fetchData(_.extend({}, this.props.default, this.param), null, false);
    };
    VTable.prototype.toPage = function (current, pageSize) {
        var _a;
        var _this = this;
        var VLIST = window.VAP_GLOBAL.VLIST;
        var resize = pageSize !== this.state.pageSize;
        var callback = function () { };
        if (resize) {
            callback = function () { return _this.reMax(); };
            window.setTimeout(function () { return _this.reMax(); }, 200);
        }
        var query = __assign(__assign({}, this.param), (_a = {}, _a[VLIST.start] = (current - 1) * pageSize, _a[VLIST.count] = pageSize, _a));
        this.param[VLIST.count] = pageSize;
        var state = { selectedRowKeys: [], selectObjects: [] };
        state.pageSize = pageSize;
        state.current = current;
        this.setState(__assign({}, state));
        this.fetchData(_.extend({}, this.props.default, query), callback, false);
    };
    VTable.prototype.renderTable = function () {
        var _this = this;
        var VLIST = window.VAP_GLOBAL.VLIST;
        var effects = this.props._loading.effects;
        var dataSource = [];
        var initing = false;
        if (_.has(this.props, 'dataSource')) {
            dataSource = this.props.dataSource;
        }
        else {
            dataSource = this.props[this.props.namespace][VLIST.list];
            if (_.has(this.props[this.props.namespace], '_loaded') && this.props[this.props.namespace]['_loaded'] === false) {
                initing = true;
            }
        }
        var selectedRowKeys = [];
        var selectObjects = [];
        var rowSelection = undefined;
        if (this.props.select) {
            dataSource.map(function (item) {
                if (_.indexOf(_this.state.selectedRowKeys, item[_this.rowKey]) >= 0) {
                    selectedRowKeys.push(item[_this.rowKey]);
                    selectObjects.push(item);
                }
            });
            rowSelection = {
                selectedRowKeys: selectedRowKeys,
                onChange: function (selectedRowKeys, selectObjects) { return _this.onSelect(selectedRowKeys, selectObjects); },
                getCheckboxProps: function (record) { return ({ disabled: !_.has(record, _this.rowKey) || (_this.props.selectDisabled && _this.props.selectDisabled(record)) }); },
            };
        }
        return React.createElement(antd_1.Table, __assign({ size: "small", rowClassName: function (item) { return _.has(item, '__EFFECT') ? 'row-high-' + item['__EFFECT'] : ''; }, locale: { emptyText: initing ? React.createElement("span", null) : React.createElement(antd_1.Empty, null) } }, this.props, { loading: effects[this.fetch], rowKey: this.rowKey, columns: this.columns, dataSource: dataSource, onChange: function (pagination, filters, sorter) { return _this.sorterField(sorter); }, rowSelection: rowSelection, pagination: false }));
    };
    VTable.prototype.renderPagination = function () {
        var _this = this;
        var _a = window.VAP_GLOBAL, VLIST = _a.VLIST, OPTIONS = _a.PAGINATION.OPTIONS;
        var total = 0;
        var totalAcc = 0;
        var dataSource = [];
        if (_.has(this.props, 'dataSource')) {
            dataSource = this.props.dataSource || [];
        }
        else {
            dataSource = this.props[this.props.namespace][VLIST.list] || [];
        }
        if (_.has(this.props, 'total')) {
            total = this.props.total;
            totalAcc = this.props.total;
        }
        else {
            total = this.props[this.props.namespace].total;
            totalAcc = this.props[this.props.namespace][VLIST.totalAcc] || total;
        }
        var current = this.state.current;
        if (_.has(this.props, 'namespace')) {
            current = this.props[this.props.namespace]._current || this.state.current;
            if (this.state.current != current) {
                this.setState({ current: current });
            }
        }
        return React.createElement(UPagination_1.default, { onChange: function (page, pageSize) { return _this.toPage(page, pageSize); }, onShowSizeChange: function (page, pageSize) { return _this.toPage(page, pageSize); }, current: current, total: total, totalAcc: totalAcc, pageSize: this.state.pageSize, pageSizeOptions: _.get(this.props.pagination, 'pageSizeOptions') || OPTIONS });
    };
    VTable.prototype.render = function () {
        var _this = this;
        var layoutStyle = {};
        if (this.mode == 'fixed') {
            var fixHeight = this.props.fixedHeight || 0;
            // @ts-ignore
            if (_.has(this.props._theme, 'contentHeight')) {
                // @ts-ignore
                layoutStyle.height = this.props._theme.contentHeight - fixHeight;
            }
        }
        var className = ['vap-table', 'vap-table-' + this.mode];
        if (this.props.fixedCol) {
            className.push('vap-table-fixcol');
        }
        return React.createElement(antd_1.Layout, { className: className.join(' '), style: layoutStyle },
            this.renderSelectBar(),
            React.createElement(antd_1.Layout, { id: this.id },
                this.renderSearchBar(),
                React.createElement(antd_1.Layout.Content, { className: "vap-table-content" }, this.renderTable()),
                this.props.pagination === false ? [] : React.createElement(antd_1.Layout.Footer, { className: "vap-table-footer" }, this.renderPagination())),
            React.createElement(antd_1.Modal, { visible: this.state.showCustom, destroyOnClose: true, title: "\u81EA\u5B9A\u4E49\u5217\u987A\u5E8F", onCancel: function () { return _this.setState({ showCustom: false, customTemp: {} }); }, onOk: function () {
                    _this.showColumns(_this.state.customTemp);
                    _this.setState({ showCustom: false });
                } },
                React.createElement(DragSort_1.default, { data: this.state.customTemp ? _.values(this.state.customTemp) : [], nameFormat: function (column) { return React.createElement("div", { style: { display: 'flex', justifyContent: 'space-between' }, key: column.key },
                        React.createElement("span", null, column.title),
                        React.createElement(antd_1.Switch, { checked: _this.state.customTemp[column.dataIndex] ? _this.state.customTemp[column.dataIndex].show : true, onChange: function (checked) { return _this.changeColumnShow(checked, column); } })); }, onChange: this.changeColumnsTemp })));
    };
    VTable.ACTION = ACTIONS_1.ACTION;
    VTable.INFO = ACTIONS_1.INFO;
    VTable.EDIT = ACTIONS_1.EDIT;
    VTable.DELETE = ACTIONS_1.DELETE;
    VTable.BUTTON_ADD = ACTIONS_1.BUTTON_ADD;
    VTable.BUTTON_DELETE = ACTIONS_1.BUTTON_DELETE;
    VTable.BUTTON_MORE = ACTIONS_1.BUTTON_MORE;
    VTable.BUTTON_IMPORT = ACTIONS_1.BUTTON_IMPORT;
    VTable.BUTTON_EXPORT = ACTIONS_1.BUTTON_EXPORT;
    return VTable;
}(React.PureComponent));
var state = function (props) { return props; };
var dispatch = undefined;
var merge = undefined;
var options = { withRef: true };
var vTable = (0, dva_1.connect)(state, dispatch, merge, options)(VTable);
vTable.prototype.query = function (param) {
    this.getWrappedInstance().query(param);
};
vTable.prototype.setColumns = function (cols, showIndex) {
    if (showIndex === void 0) { showIndex = null; }
    this.getWrappedInstance().setColumns(cols, showIndex);
};
vTable.prototype.reflush = function (param) {
    if (param === void 0) { param = {}; }
    this.getWrappedInstance().reflush(param);
};
vTable.prototype.setSelected = function (keys) {
    return this.getWrappedInstance().setSelected(keys);
};
vTable.prototype.getSelected = function () {
    return this.getWrappedInstance().getSelected();
};
vTable.prototype.getParam = function () {
    return this.getWrappedInstance().getParam();
};
vTable.prototype.INFO = ACTIONS_1.INFO;
vTable.prototype.EDIT = ACTIONS_1.EDIT;
vTable.prototype.DELETE = ACTIONS_1.DELETE;
vTable.prototype.ACTION = ACTIONS_1.ACTION;
exports.default = vTable;
