"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
var d3 = require("d3");
var D3Chart_1 = require("../D3Chart");
var colorArr = [
    '#ff8300', '#9e2ca7', '#00030b',
    '#3e80ff', '#ccb800', '#547774',
    '#fe95d0', '#57bccd', '#af89af'
];
var default_1 = /** @class */ (function (_super) {
    __extends(default_1, _super);
    function default_1() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    //数据初始化
    default_1.prototype.init = function () {
        var pieLen = this.WIDTH < this.HEIGHT - 20 ? this.WIDTH : this.HEIGHT - 20;
        this.WIDTH = pieLen;
        this.HEIGHT = pieLen + 20;
    };
    //数据排序 | 数据转换结构
    default_1.prototype.sort = function () {
        var _this = this;
        var total = _.sumBy(this.props.data, this.props.valueField);
        var newData = {};
        var _loop_1 = function () {
            var item = this_1.props.data[i];
            var name_1 = item[this_1.props.labelField];
            var value = item[this_1.props.valueField];
            if (_.has(item, "children")) {
                newData[name_1] = [name_1, [value, (value * 100 / total).toFixed(2) + "%"]];
                _list = {};
                item.children.map(function (d) {
                    var _name = d[_this.props.labelField];
                    var _value = d[_this.props.valueField];
                    _list[_name] = [_name, [_value, (_value * 100 / total).toFixed(2) + "%", (_value * 100 / value).toFixed(2) + "%"]];
                });
                newData[name_1].push(_list);
            }
            else {
                newData[name_1] = [name_1, [value, (value * 100 / total).toFixed(2) + "%"]];
            }
        };
        var this_1 = this, _list;
        for (var i in this.props.data) {
            _loop_1();
        }
        this.DATA = ["全部", [total, "100%"], newData];
    };
    default_1.prototype._warpToArcData = function (data) {
        var data_slices = [];
        //通过计算得到圆环对应的角度      
        function process_data(data, level, start_deg, stop_deg) {
            var name = data[0];
            var total = data[1][0];
            var children = data[2];
            var current_deg = start_deg;
            if (level > 4) {
                return;
            }
            if (start_deg == stop_deg) {
                return;
            }
            data_slices.push([start_deg, stop_deg, name, level, data[1]]);
            for (var key in children) {
                var child = children[key];
                var inc_deg = (stop_deg - start_deg) / total * child[1][0];
                var child_start_deg = current_deg;
                current_deg += inc_deg;
                var child_stop_deg = current_deg;
                process_data(child, level + 1, child_start_deg, child_stop_deg);
            }
        }
        process_data(data, 0, 0, 360. / 180.0 * Math.PI);
        return data_slices;
    };
    //绘图
    default_1.prototype.build = function () {
        var self = this;
        var data_slices = this._warpToArcData(self.DATA);
        var ref = data_slices[0];
        var last_refs = [];
        var thickness = self.WIDTH / 2.0 / (4 + 2) * 1.1;
        function setText(d) {
            return "<tspan style='font-family:cursive'>\u5730\u533A</tspan>\uFF1A".concat(d[2], "&nbsp;&nbsp;&nbsp;<tspan style='font-family:cursive'\n            >\u6570\u91CF</tspan>\uFF1A").concat(d[4][0], "&nbsp;&nbsp;&nbsp;<tspan style='font-family:cursive'>\u5360\u6BD4</tspan>\uFF1A").concat(d[4][1]);
        }
        //添加text
        this.SVG.append("text")
            .attr("class", "text")
            .attr("x", self.WIDTH / 2)
            .attr('y', 35)
            .attr("text-anchor", "middle")
            .html(setText(ref));
        //绘制圆环
        var arc = d3.arc()
            .startAngle(function (d) { return d[3] == 0 ? d[0] : d[0] + 0.01; })
            .endAngle(function (d) { return d[3] == 0 ? d[1] : d[1] - 0.01; })
            .innerRadius(function (d) { return 1.2 * d[3] * thickness; })
            .outerRadius(function (d) { return (1.2 * d[3] + 1) * thickness; });
        var slices = self.SVG.selectAll(".form")
            .data(data_slices).enter().append("g");
        slices.append("path").attr("d", arc).attr("class", "form")
            .style("fill", function (d) { return d[3] == 0 ? "white" : colorArr[Math.floor(Math.random() * 10)]; })
            .attr("transform", "translate(".concat(self.WIDTH / 2, ",").concat((self.HEIGHT / 2) + 20, ")"));
        slices.on("click", animate);
        slices.on("mouseover", function (d) {
            self.SVG.select(".text").html(setText(d));
        });
        function get_start_angle(d, ref) {
            return ref ? (d[0] - ref[0]) / (ref[1] - ref[0]) * Math.PI * 2.0 : d[0];
        }
        function get_stop_angle(d, ref) {
            return ref ? (d[1] - ref[0]) / (ref[1] - ref[0]) * Math.PI * 2.0 : d[0];
        }
        function get_level(d, ref) {
            return ref ? (d[3] - ref[3]) : d[3];
        }
        function rebaseTween(new_ref) {
            return function (d) {
                var level = d3.interpolate(get_level(d, ref), get_level(d, new_ref));
                var start_deg = d3.interpolate(get_start_angle(d, ref), get_start_angle(d, new_ref));
                var stop_deg = d3.interpolate(get_stop_angle(d, ref), get_stop_angle(d, new_ref));
                return function (t) {
                    //@ts-ignore
                    return arc([start_deg(t), stop_deg(t), d[2], level(t)]);
                };
            };
        }
        var animating = false;
        function animate(d) {
            if (animating) {
                return;
            }
            animating = true;
            var revert = false;
            var new_ref;
            var last_ref;
            if (d == ref && last_refs.length > 0) {
                revert = true;
                last_ref = last_refs.pop();
            }
            if (revert) {
                d = last_ref;
                new_ref = ref;
                self.SVG.selectAll(".form")
                    .filter(function (b) { return b[0] >= last_ref[0] && b[1] <= last_ref[1] && b[3] >= last_ref[3] ? true : false; })
                    .transition().duration(1000).style("opacity", "1").attr("pointer-events", "all");
            }
            else {
                new_ref = d;
                self.SVG.selectAll(".form")
                    .filter(function (b) { return b[0] < d[0] || b[1] > d[1] || b[3] < d[3] ? true : false; })
                    .transition().duration(1000).style("opacity", "0").attr("pointer-events", "none");
            }
            self.SVG.selectAll(".form")
                .filter(function (b) { return b[0] >= new_ref[0] && b[1] <= new_ref[1] && b[3] >= new_ref[3] ? true : false; })
                .transition().duration(1000).attrTween("d", rebaseTween(d));
            setTimeout(function () {
                animating = false;
                if (!revert) {
                    last_refs.push(ref);
                    ref = d;
                }
                else {
                    ref = d;
                }
            }, 1000);
        }
        ;
    };
    // 更新数据
    default_1.prototype.update = function () {
    };
    return default_1;
}(D3Chart_1.default));
exports.default = default_1;
