/// <reference types="react" />
import { CardProps } from 'antd/lib/card';
import { RowProps } from 'antd/lib/row';
export interface CardTabListType {
    key: string;
    tab: React.ReactNode;
    content?: React.ReactNode;
}
export interface PanelProps extends CardProps {
    /**
     * 标题前面打个 ICON图标
    */
    icon?: string;
    /**
     * 宽度
    */
    width?: number;
    /**
     * 有些一级的SVG图像有Resize问题，存在问题时需要增加fixed=true
    */
    /**
     * 跨度大小，分成24份
    */
    span?: number;
    /**
     * 标签页
    */
    tabList?: CardTabListType[];
    /**
     * 是否固定
    */
    fixed?: number;
}
export interface RowPanelProps extends CardProps {
    /**
     * 标题前面打个 ICON图标
    */
    icon?: string;
    /**
     * Panel高度
    */
    height: number | string;
    /**
     * 标签页
    */
    tabList?: CardTabListType[];
}
export interface VRowProps extends RowProps {
    height: number | string;
}
