import { ModalProps } from 'antd/lib/modal/Modal';
import { DataColumn } from '../Table/interface';
export interface Option {
    name: string;
    value: string | number;
}
export interface SearchConf {
    title: string;
    field: string;
}
export interface TableModalProps<T> extends ModalProps {
    /**
     * 查询接口地址，必须是POST
    */
    query: string;
    /**
     * 是否显示
    */
    show: boolean;
    /**
     * 列定义
    */
    columns?: DataColumn<T>[];
    /**
     * 基本查询参数
    */
    param?: any;
    /**
     * 导出地址
    */
    export?: string;
    /**
     * 搜索条件配置
    */
    search?: SearchConf[];
    /**
     * 是否显示SizeChanger
     */
    showSizeChanger?: boolean;
}
