import * as React from "react";
import { Bound } from './utils';
export interface GridItemProps {
    /**外部容器属性 */
    col: number;
    containerWidth: number;
    containerPadding: [number, number];
    /**子元素的属性 */
    margin?: [number, number];
    GridX: number;
    GridY: number;
    rowHeight: number;
    /**子元素的宽高 */
    w: number;
    h: number;
    /**生命周期回掉函数 */
    onDragStart?: (event: GridItemEvent) => void;
    onDragEnd?: (event: GridItemEvent) => void;
    onDrag?: (event: GridItemEvent) => void;
    onResizeStart?: (event: GridItemEvent) => void;
    onResizing?: (event: GridItemEvent) => void;
    onResizeEnd?: (event: GridItemEvent) => void;
    isUserMove: Boolean;
    UniqueKey?: string;
    static?: Boolean;
    style?: React.CSSProperties;
    bounds?: Bound | 'parent';
    dragType: 'drag' | 'resize';
    handle?: Boolean;
    canDrag?: Boolean;
    canResize?: Boolean;
    children: (provided: any, draggerProps: any, resizerProps: any) => any;
}
export interface GridItemEvent {
    event: any;
    GridX: number;
    GridY: number;
    w: number;
    h: number;
    UniqueKey: string | number;
}
export default class GridItem extends React.Component<GridItemProps, {}> {
    constructor(props: GridItemProps);
    static defaultProps: {
        col: number;
        containerWidth: number;
        containerPadding: number[];
        margin: number[];
        rowHeight: number;
        w: number;
        h: number;
    };
    /** 计算容器的每一个格子多大 */
    calColWidth(): number;
    /**转化，计算网格的GridX,GridY值 */
    calGridXY(x: number, y: number): {
        GridX: number;
        GridY: number; /**子元素的宽高 */
    };
    /**给予一个grid的位置，算出元素具体的在容器中位置在哪里，单位是px */
    calGridItemPosition(GridX: number, GridY: number): {
        x: number;
        y: number;
    };
    shouldComponentUpdate(props: GridItemProps, state: any): boolean;
    /**宽和高计算成为px */
    calWHtoPx(w: number, h: number): {
        wPx: number;
        hPx: number;
    };
    calPxToWH(wPx: number, hPx: number): {
        w: number;
        h: number;
    };
    onDragStart(x: number, y: number): void;
    onDrag(event: any, x: number, y: number): void;
    onDragEnd(event: any, x: number, y: number): void;
    onResizeStart: (event: any, wPx: number, hPx: number) => void;
    onResizing: (event: any, wPx: number, hPx: number) => void;
    onResizeEnd: (event: any, wPx: number, hPx: number) => void;
    render(): JSX.Element;
}
