/**
 * 说明： doLoad 是一个更高阶的 doSetState, 支持异步方法，说明：可能会有BUG （尤其是在方法速度慢的时候）
 *
 * const [state,doLoad] =  useDoLoad({a:1,b:2,c:3});
 *
 * doLoad({b:5})
 *
 * doLoad((prevState)=>return {
 *      c:prevState + 1
 * })
 *
 * doLoad(async (prevState) =>{
 *  const resp = await Ajax.GET('API')
 *  return { c:resp.xxx }
 * })
*/
export declare const useDoLoad: <T extends object>(initValue: T) => [T, (patch: Partial<T> | ((prevState: T) => Partial<T>) | ((prevState: T) => Promise<Partial<T>>)) => void];
