import type { UModalProps } from '../_common/UForm/interface';
type ModalsState = {
    modalProps: Pick<UModalProps, 'visible' | 'onCancel' | 'data' | 'isEdit'>;
    visible: boolean;
    isEdit: boolean;
    data: any;
    /**
     * 仅仅是一个boolean值，通常用于页面有 UploadModal 时使用， 也可自定义于其它Modal
     * 对应方法 ：showUpload
     * */
    openUpload: boolean;
    /**
     * 仅仅是一个boolean值，通常用于页面有 ApiTableModal 时使用， 也可自定义于其它Modal
     * 对应方法 ：showDetail
     * */
    openDetail: boolean;
    /**
     * 说明
     * extra 是用于自行扩展的对象
    */
    extra?: any;
};
/**
 * useModals 提供了常用页面处理弹框的一个快捷封装
 * 用于 添加、编辑 数据 ，及查看数据详情的 UModal
 * 及 导入 UploadModal 的显示/隐藏控制参数 UploadModal
 *
 * 此Hook 没有提供任何数据操作，通常与 useApi返回的模型结合使用。
*/
export declare const useModals: () => {
    modalState: ModalsState;
    hide: (extra?: any) => void;
    showInfo: (data: any, extra?: any) => void;
    showAdd: (extra?: any) => void;
    showEdit: (data: any, extra?: any) => void;
    showUpload: (extra?: any) => void;
    showDetail: (data?: any, extra?: any) => void;
};
export {};
