"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useModals = void 0;
var react_1 = require("react");
/**
 * useModals 提供了常用页面处理弹框的一个快捷封装
 * 用于 添加、编辑 数据 ，及查看数据详情的 UModal
 * 及 导入 UploadModal 的显示/隐藏控制参数 UploadModal
 *
 * 此Hook 没有提供任何数据操作，通常与 useApi返回的模型结合使用。
*/
var useModals = function () {
    var _a = __read((0, react_1.useState)({
        modalProps: {
            visible: false, data: null, isEdit: false,
            onCancel: function (extra) {
                setState(function (prev) {
                    var result = {
                        visible: false, openDetail: false, openUpload: false, isEdit: false, data: prev.data,
                        modalProps: __assign(__assign({}, prev.modalProps), { visible: false })
                    };
                    if (extra !== undefined)
                        result.extra = extra;
                    return result;
                });
            }
        },
        visible: false,
        openUpload: false,
        openDetail: false,
        isEdit: false,
        data: {},
        extra: null,
    }), 2), modalState = _a[0], setState = _a[1];
    var hide = function (extra) { return setState(function (prev) {
        var result = {
            visible: false, openDetail: false, openUpload: false, isEdit: false, data: prev.data,
            modalProps: __assign(__assign({}, prev.modalProps), { visible: false, isEdit: false, data: null })
        };
        if (extra !== undefined)
            result.extra = extra;
        return result;
    }); };
    var showInfo = function (data, extra) { return setState(function (prev) {
        var result = {
            visible: true, openDetail: false, openUpload: false, isEdit: false,
            data: data,
            modalProps: __assign(__assign({}, prev.modalProps), { visible: true, data: data, isEdit: false })
        };
        if (extra !== undefined)
            result.extra = extra;
        return result;
    }); };
    var showAdd = function (extra) { return setState(function (prev) {
        var result = {
            visible: true, openDetail: false, openUpload: false, data: null, isEdit: false,
            modalProps: __assign(__assign({}, prev.modalProps), { visible: true, data: null, isEdit: false })
        };
        if (extra !== undefined)
            result.extra = extra;
        return result;
    }); };
    var showEdit = function (data, extra) { return setState(function (prev) {
        var result = {
            visible: true, openDetail: false, openUpload: false,
            data: data,
            isEdit: true,
            modalProps: __assign(__assign({}, prev.modalProps), { visible: true, data: data, isEdit: true })
        };
        if (data !== undefined)
            result.data = data;
        if (extra !== undefined)
            result.extra = extra;
        return result;
    }); };
    var showUpload = function (extra) { return setState(function (prev) {
        var result = {
            visible: false, openDetail: false, openUpload: true, data: prev.data, isEdit: false,
            modalProps: __assign(__assign({}, prev.modalProps), { visible: false })
        };
        if (extra !== undefined)
            result.extra = extra;
        return result;
    }); };
    var showDetail = function (data, extra) { return setState(function (prev) {
        var result = {
            visible: false, openDetail: true, openUpload: false, data: prev.data, isEdit: false,
            modalProps: __assign(__assign({}, prev.modalProps), { visible: false })
        };
        if (data !== undefined)
            result.data = data;
        if (extra !== undefined)
            result.extra = extra;
        return result;
    }); };
    return {
        modalState: modalState,
        hide: hide,
        showInfo: showInfo,
        showAdd: showAdd,
        showEdit: showEdit,
        showUpload: showUpload,
        showDetail: showDetail,
    };
};
exports.useModals = useModals;
