"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useToggle = void 0;
var react_1 = require("react");
var toggleReducer = function (state, nextValue) {
    return typeof nextValue === 'boolean' ? nextValue : !state;
};
/**
 * 使用方法参考
 * https://github.com/streamich/react-use/blob/master/docs/useToggle.md
*/
var useToggle = function (initialValue) {
    if (initialValue === void 0) { initialValue = false; }
    return (0, react_1.useReducer)(toggleReducer, initialValue);
};
exports.useToggle = useToggle;
