"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.VNumberGrid = void 0;
var React = require("react");
var _ = require("lodash");
var dva_1 = require("dva");
var antd_1 = require("antd");
var _Panel_1 = require("./_Panel");
/**
 * Grid 系列：
 * 1. GridNumber : 展示一个数字
 * 1. GridNumbers : 展示多个数字
 * 2. BannerGrid : 展示一幅Banner
 * 3. ChartGrid : 展示一个Chart (通常用于比较小的，嵌入式，比较大的使用 Col)
 *
*/
var NumberGrid = /** @class */ (function (_super) {
    __extends(NumberGrid, _super);
    function NumberGrid() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    NumberGrid.prototype.renderContent = function () {
        var style = this.props.contentStyle ? this.props.contentStyle : {};
        if (this.isLoading()) {
            return React.createElement("div", { className: "content-blank", style: style },
                React.createElement(antd_1.Spin, null));
        }
        if (this.isEmpty()) {
            return React.createElement("div", { className: "content-blank", style: style },
                React.createElement(antd_1.Empty, { description: this.props.emptyText || '暂无数据' }));
        }
        if (_.has(this.props, 'numberValue')) {
            var str = this.props.numberValue;
            if (this.props.numberFormat) {
                if (_.isFunction(this.props.numberFormat)) {
                    // @ts-ignore
                    str = this.props.numberFormat(str);
                }
                else {
                    // @ts-ignore
                    var render = this.props._renders.getFormatRender(this.props.numberFormat);
                    str = render(str);
                }
            }
            return React.createElement("div", { className: "content-blank", style: style },
                React.createElement("div", { className: "v-content" }, str));
        }
        return React.createElement("div", { className: "content-blank", style: style },
            React.createElement("div", { className: "v-content" }, this.props.children)) || [];
    };
    NumberGrid.prototype.render = function () {
        var _this = this;
        var _a = this.props, xs = _a.xs, sm = _a.sm, md = _a.md, lg = _a.lg, xl = _a.xl, span = _a.span, title = _a.title, icon = _a.icon, titleDesc = _a.titleDesc, noBg = _a.noBg, className = _a.className, _b = _a.type, type = _b === void 0 ? 'default' : _b;
        var colParam = _.extend({ xs: 24 }, { xs: xs, sm: sm, md: md, lg: lg, xl: xl, span: span });
        var clazz = ['vpanel', 'vpanel-grid'];
        var hasTitle = false;
        var hasIcon = false;
        if (type === 'fullBg') {
            clazz.push('vpanel-fullBg');
        }
        if (noBg) {
            clazz.push('vpanel-nobg');
        }
        if (title) {
            hasTitle = true;
            if (icon) {
                hasIcon = true;
            }
            if (titleDesc) {
                clazz.push('vpanel-complex');
            }
        }
        else {
            clazz.push('vpanel-notitle');
        }
        if (!colParam.span) {
            if (!_.has(this.props.style, 'width') && !_.has(this.props.style, 'height')) {
                colParam.className = 'vcol-nospan';
            }
        }
        // clazz.push('vpanel-number')
        if (_.has(this.props, 'linkTo')) {
            if (_.startsWith(this.props.linkTo, 'http://') || _.startsWith(this.props.linkTo, 'https://')) {
                clazz.push('vpanel-hover');
                // @ts-ignore
                colParam.onClick = function () { return _this.props.dispatch({ type: '_menus/toMenu', menu: { path: _this.props.linkTo } }); };
            }
            else {
                var ptns_1 = _.split(this.props.linkTo, '#');
                if (ptns_1.length == 2) {
                    clazz.push('vpanel-hover');
                    // @ts-ignore
                    colParam.onClick = function () { return _this.props.dispatch({ type: '_menus/toMenu', menu: { root: ptns_1[0], route: ptns_1[1] } }); };
                }
            }
        }
        else if (_.has(this.props, 'onClick')) {
            clazz.push('vpanel-hover');
            colParam.onClick = function () { return _this.props.onClick(); };
        }
        if (this.props.bgStyle) {
            clazz.push('vpanel-grid-' + this.props.bgStyle);
            if (_.has(this.props, 'bgStrength')) {
                clazz.push('vpanel-grid-' + this.props.bgStrength);
            }
        }
        if (className) {
            clazz.push(className);
        }
        return React.createElement(antd_1.Col, __assign({}, colParam, { style: this.props.style }),
            React.createElement("div", { className: clazz.join(' ') },
                React.createElement("div", { className: "vpanel-content" }, this.renderContent()),
                hasTitle && React.createElement("div", { className: "vpanel-title" + (hasIcon ? ' vpanel-title-with-icon' : '') }, this.renderTitle())));
    };
    return NumberGrid;
}(_Panel_1.Panel));
exports.VNumberGrid = (0, dva_1.connect)(function (_a) {
    var _loading = _a._loading, _renders = _a._renders;
    return ({ _loading: _loading, _renders: _renders });
})(NumberGrid);
