/**
 * 吉大正元 PKI 证书登录, 已经内置所有已知的KEY，
 *
 * 大致使用方式 如下
 * import { JitClient } from 'vap2/login/jit'
 * const client = JitClient();                                  // 接收 1-3个参数，用于不同版本的控制
 * const randomNumber = await Ajax.GET('/api/randomNumber');    // 后端 生成一个随机数
 * const param = client.getLoginParam(randomNumber);            // 插件 获取登录参数
 * const loginResult = await Ajax.GET('/api/pkilogin');         // 后端 登录接口
 *
 * 如果 key 未知时，getLoginParam 需要传新的KEY
*/
export declare enum BROWSER_MODE {
    IE = 0,
    CHROME = 1,
    CHROME_OLD = 2
}
export declare class JitClient {
    private initParam;
    /**
     * @param initParam         插件初始化参数，是一个XML字符串，在不同的项目，参数会不同，可以配置在后端返回
     * @param enablectiveX      是否支持 旧版本 IE ActiveX 登录 , 默认支持
     * @param enableNPPlugin    是否支持 旧版本 Chrome NppPlugin 登录 ， 默认支持，部分地区不支持
    */
    constructor(initParam?: string, enablectiveX?: boolean, enableNPPlugin?: boolean);
    getBrowserInfo(): BROWSER_MODE;
    getLoginParam(randNum: any, initParam?: string): {
        original: string;
        signed_data: string;
        authMode: 'cert';
    } | false;
}
