"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var mockjs_1 = require("mockjs");
var _ = require("lodash");
var moment = require("moment");
var NUMBER = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9];
var PHONE_PREFIX = [
    130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 151, 152, 177, 159
];
var MockTemplate = /** @class */ (function () {
    function MockTemplate() {
    }
    MockTemplate.prototype.buildResponse = function (type, template, size) {
        var _a, _b, _c, _d, _e, _f;
        if (size === void 0) { size = 100; }
        var _g = window.VAP_GLOBAL, RESULT = _g.RESULT, VLIST = _g.VLIST, VDATA = _g.VDATA;
        switch (type.toLowerCase()) {
            case 'custom':
                return (0, mockjs_1.mock)(template);
            case 'fixed':
                return template;
            case 'vlist':
                return __assign((_a = {}, _a[RESULT.code] = RESULT.success, _a[RESULT.message] = 'Success', _a[VLIST.total] = size, _a), (0, mockjs_1.mock)((_b = {},
                    _b["".concat(VLIST.list, "|15")] = [template],
                    _b)));
            case 'vdata':
                if (_.isArray(template) && template.length == 1) {
                    return __assign((_c = {}, _c[RESULT.code] = RESULT.success, _c[RESULT.message] = 'Success', _c), (0, mockjs_1.mock)({
                        "data|10": [template[0]]
                    }));
                }
                return _d = {},
                    _d[RESULT.code] = RESULT.success,
                    _d[RESULT.message] = 'Success',
                    _d[VDATA.data] = (0, mockjs_1.mock)(template),
                    _d;
            case 'result':
                return __assign((_e = {}, _e[RESULT.code] = RESULT.success, _e[RESULT.message] = 'Success', _e), (0, mockjs_1.mock)(template));
            default:
                return _f = {},
                    _f[RESULT.code] = '99996',
                    _f[RESULT.message] = 'Not Support Type : ' + type,
                    _f;
        }
    };
    MockTemplate.prototype.init = function () {
        // @ts-ignore
        mockjs_1.Random.extend({
            _lock: function (fn, value) {
                if (value) {
                    this['_locks_' + fn] = value;
                    this['_locks_' + fn + '_time'] = _.now();
                    return;
                }
                if (_.has(this, '_locks_' + fn)) {
                    var last = this['_locks_' + fn + '_time'];
                    if (_.now() - last <= 2) {
                        return this['_locks_' + fn];
                    }
                }
                return null;
            },
            numberSort: function (max, min, size, sort) {
                if (max === void 0) { max = 99999; }
                if (min === void 0) { min = max / 10; }
                if (size === void 0) { size = 15; }
                if (sort === void 0) { sort = 'desc'; }
                var key = "numberSorter_".concat(max, "_").concat(min, "_").concat(size, "_").concat(sort);
                var last = this._lock(key);
                var split = (max - min) / size;
                var result = 0;
                if (last != null) {
                    result = Math.ceil(last - _.random(0, split));
                }
                else {
                    result = Math.ceil(max - _.random(0, split));
                }
                this._lock(key, result);
                return result;
            },
            phone: function () {
                var phone = _.sample(PHONE_PREFIX) + '';
                for (var i = 0; i < 8; i++) {
                    phone = phone + _.sample(NUMBER);
                }
                return phone;
            },
            idcard: function () {
                return mockjs_1.Random.id();
            },
            vdate: function (day, format) {
                if (day === void 0) { day = 30; }
                if (format === void 0) { format = 'YYYY-MM-DD'; }
                return moment().subtract(_.random(0, day), 'days').hour(0).minute(0).second(0).format(format);
            },
            vdatetime: function (day, format) {
                if (day === void 0) { day = 30; }
                if (format === void 0) { format = 'YYYY-MM-DD hh:mm:ss'; }
                return moment().subtract(_.random(0, day), 'days').hour(_.random(0, 23)).minute(_.random(0, 59)).second(_.random(0, 59)).format(format);
            }
        });
    };
    return MockTemplate;
}());
exports.default = new MockTemplate();
