import * as React from 'react';
/**
 * 大屏组件属性
*/
export interface CommentProps {
    /**
     * 组件样式，说明：width height left top position 的样式会使用 参数的，在这里写无效
    */
    style?: React.CSSProperties;
    /**
     * class 属性
    */
    className?: string;
    /**
     * id属性
    */
    id?: string;
    /**
     * 组件宽度
    */
    width: number | string;
    /**
     * 组件高度
    */
    height: number | string;
    /**
     * 组件左边距
    */
    left: number | string;
    /**
     * 组件上边距
    */
    top: number | string;
}
/**
 * 大屏Echarts组件属性
*/
export interface EchartCommentProps {
    /**
     * class 属性
    */
    className?: string;
    /**
     * 组件样式
    */
    style?: React.CSSProperties;
    /**
     * 组件宽度
    */
    width?: number | string;
    /**
     * 组件高度
    */
    height?: number | string;
    /**
     * Echart数据
    */
    data: any;
}
