"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var moment = require("moment");
var dayStart = function (m) { return m.hours(0).minutes(0).seconds(0); };
var dayEnd = function (m) { return m.hours(23).minutes(59).seconds(59); };
var default_1 = /** @class */ (function () {
    function default_1() {
    }
    /**
     * 特殊字符
    */
    default_1.SPECIAL_CHARACTER = /[\/'"#$:?：!！？%￥&^*]/im;
    // static SPECIAL_CHARACTER = /[`~!@#$%^&*()_\-+=<>?:"{}|,.\/;'\\[\]·~！@#￥%……&*（）——\-+={}|《》？：“”【】、；‘’，。、]/im;
    /***
    * 身份证号（支持15/18位）
    */
    default_1.REGEXP_IDCARD = /(^[1-9]\d{5}(18|19|([23]\d))\d{2}((0[1-9])|(10|11|12))(([0-2][1-9])|10|20|30|31)\d{3}[0-9Xx]$)|(^[1-9]\d{5}\d{2}((0[1-9])|(10|11|12))(([0-2][1-9])|10|20|30|31)\d{3}$)/;
    default_1.DATE_RANGE_COMMON = {
        '今天': [dayStart(moment()), dayEnd(moment())],
        '本月': [dayStart(moment().set('date', 1)), dayEnd(moment())],
        '近三天': [dayStart(moment().subtract(3, 'days')), dayEnd(moment())],
        '近七天': [dayStart(moment().subtract(7, 'days')), dayEnd(moment())],
        '上月': [dayStart(moment().subtract(1, 'months').set('date', 1)), dayEnd(moment().set('date', 1).subtract(1, 'days'))],
    };
    default_1.DATE_RANGE_COMMON_MORE = {
        '今天': [dayStart(moment()), dayEnd(moment())],
        '本月': [dayStart(moment().set('date', 1)), dayEnd(moment())],
        '近三天': [dayStart(moment().subtract(3, 'days')), dayEnd(moment())],
        '近七天': [dayStart(moment().subtract(7, 'days')), dayEnd(moment())],
        '上月': [dayStart(moment().subtract(1, 'months').set('date', 1)), dayEnd(moment().set('date', 1).subtract(1, 'days'))],
        '近三月': [dayStart(moment().subtract(3, 'months').set('date', 1)), dayEnd(moment())],
        '今年': [dayStart(moment().set('months', 0).set('date', 1)), dayEnd(moment())],
    };
    /**
     * 通用分页
    */
    default_1.PAGE_OPTIONS = ["10", "15", "30"];
    /**
     * 启用 / 禁用 Switch 开关选项，用于表单元素的输入
     * ```
     *  {name:'启用',value:'0'},
     *  {name:'禁用',value:'1'}
     * ```
    */
    default_1.STATUS_OPTION = [{ name: '启用', value: '0' }, { name: '禁用', value: '1' }];
    /**
     * 全部 / 启用 / 禁用 过滤器 定义，用于 Table 头上的过滤搜索
     * ```
     *  {name:'全部',value:''},
     *  {name:'启用',value:'0'},
     *  {name:'禁用',value:'1'}
     * ```
    */
    default_1.STATUS_FILTER = [{ name: '全部', value: '' }, { name: '启用', value: '0' }, { name: '禁用', value: '1' }];
    /**
    *  启用 / 禁用 映射文字，用于将值传为文字进行显示
     * ```
     * {
     *  '0':'是',
     *  '1':'否'
     * }
     * ```
    */
    default_1.STATUS_MAP = { '0': '启用', '1': '禁用' };
    /**
     * 是 / 否 Switch 开关选项，用于表单元素的输入
     * ```
     *  {name:'是',value:'0'},
     *  {name:'否',value:'1'}
     * ```
    */
    default_1.IS_NOT_OPTION = [{ name: '是', value: '0' }, { name: '否', value: '1' }];
    /**
     * 全部 / 是 / 否 过滤器 定义，用于 Table 头上的过滤搜索
     * ```
     *  {name:'全部',value:''},
     *  {name:'是',value:'0'},
     *  {name:'否',value:'1'}
     * ```
    */
    default_1.IS_NOT_FILTER = [{ name: '全部', value: '' }, { name: '是', value: '0' }, { name: '否', value: '1' }];
    /**
    *  是 / 否 映射文字，用于将值传为文字进行显示
     * ```
     * {
     *  '0':'是',
     *  '1':'否'
     * }
     * ```
    */
    default_1.IS_NOT_MAP = { '0': '是', '1': '否' };
    /**
     * 异常报警类型
    */
    default_1.DICT_WARN_TYPE = 'fad2c67f-d696-11e8-8a6d-000c29d87e13';
    /**
     * 系统类型  1. 系统 ，2，网站
     * */
    default_1.DICT_SYS_TYPE = '6edc437f-d69b-11e8-8a6d-000c29d87e13';
    /**
     * 人员类型  1.警员 2. 辅警 3. 外协
     * */
    default_1.DICT_PERSON_TYPE = '1ab4bf9a-d697-11e8-8a6d-000c29d87e13';
    /**
     * 对象类型
     */
    default_1.DICT_OBJECT_TYPE = '8d5b99ac-d694-11e8-8a6d-000c29d87e13';
    /**
     * PKI警种 Render
    */
    default_1.DICT_POLICE_TYPE_PKI = '22ea36ca-c075-11e8-9405-00163e00156d';
    /**
     * 人员警种 Render
    */
    default_1.DICT_POLICE_TYPE = '61124420-c206-11e8-9405-00163e00156d';
    /**
    * 威胁类型 render
   */
    default_1.DICT_THREAT_TYPE = 'df7ffe7f-d694-11e8-8a6d-000c29d87e13';
    /**
     * 证书状态
    */
    default_1.DICT_PKI_STATUS = '22ea3960-c075-11e8-9405-00163e00156d';
    /**
   * 站点类型分类 siteType Render
  */
    default_1.DICT_SITE_TYPE = '0795411c-d695-11e8-8a6d-000c29d87e13';
    /**
    * 登录类型(安全级别) Render
    */
    default_1.DICT_LOGIN_TYPE = '26a0dbf1-d695-11e8-8a6d-000c29d87e13';
    /**
     * 岗位类型
    */
    default_1.DICT_STATION_TYPE = '22ea3346-c075-11e8-9405-00163e00156d';
    /**
     * 应用 ：服务器类型
    */
    default_1.DICT_SYS_SERVER_TYPE = '64046848-d695-11e8-8a6d-000c29d87e13';
    /**
     * 应用 建库模式
    */
    default_1.DICT_SYS_CREATE_MODEL = '77fb6e05-d695-11e8-8a6d-000c29d87e13';
    /**
     * 应用 操作系统类型
    */
    default_1.DICT_SYS_OS_TYPE = '9c572379-d695-11e8-8a6d-000c29d87e13';
    /**
     * 应用 数据库类型
    */
    default_1.DICT_SYS_APP_DATABASE_TYPE = 'd9438b03-d695-11e8-8a6d-000c29d87e13';
    /**
     * 应用 应用系统来源
    */
    default_1.DICT_SYS_SOURCE_TYPE = 'eea1666e-d695-11e8-8a6d-000c29d87e13';
    /**
     * 应用 字符集
    */
    default_1.DICT_SYS_CHARTSET = 'fe131890-d695-11e8-8a6d-000c29d87e13';
    /**
     * 应用 网络
    */
    default_1.DICT_SYS_NETWORK = '2bd99a1c-d696-11e8-8a6d-000c29d87e13';
    /**
     * 应用 个人用户登录方式
    */
    default_1.DICT_SYS_USER_LOGIN_TYPE = '530a04a2-d696-11e8-8a6d-000c29d87e13';
    /**
     * 应用 账户类型
    */
    default_1.DICT_SYS_ACCOUNT_TYPE = '6b88fcce-d696-11e8-8a6d-000c29d87e13';
    /**
     * 应用 系统等级
    */
    default_1.DICT_SYS_LEVEL = '8b6a9768-d696-11e8-8a6d-000c29d87e13';
    /**
     * 应用 系统状态
    */
    default_1.DICT_SYS_STATE = 'ae512ca8-d696-11e8-8a6d-000c29d87e13';
    /**
     * 应用 应用类型
    */
    default_1.DICT_SYS_APP_TYPE = '9b2e332d-d696-11e8-8a6d-000c29d87e13';
    /***
     * 资产风险等级
     * */
    default_1.DICT_WARN_LEVEL = '7d61fb71-cb6f-11e8-b6f6-000c29d87e13';
    /**
     *告警处置状态
    */
    default_1.DICT_ALARM_STATUS = 'ed32a60b-cb6f-11e8-b6f6-000c29d87e13';
    /**
     * 通用二元状态： 启用，禁用
     * */
    default_1.DICT_OPEN_CLOSE = '6a22e161-d74a-11e8-8a6d-000c29d87e13';
    /**
     * 通用二元状态： 是，否
     * */
    default_1.DICT_YES_NO = '5b4d77de-d74a-11e8-8a6d-000c29d87e13';
    /**
     *设备类型
     * */
    default_1.DEVICE_TYPE = '22ea3b7d-c075-11e8-9405-00163e00156d';
    /**
     * 攻击类型
     */
    default_1.ATTACK_TYPE = '2fadddc8-ee20-11e8-a1b8-6c92bf88492c';
    /**
     * 公司简称
     */
    default_1.DICT_COMPANY_DESC = '22ea2fc0-c075-11e8-9405-00163e00156d';
    /**
     * 请求方法
     */
    default_1.DICT_REQUEST_METHOD = '7c38a2d0-d04c-11e9-84fa-000c295931fb';
    /**
     * 执行策略
     */
    default_1.DICT_EXECUTE_STRATEGY = 'f9aa28be-d04c-11e9-84fa-000c295931fb';
    /**
     * waf攻击事件类型
     */
    default_1.DICT_WAF_ATTACK_TYPE = 'bc994d6a-d04d-11e9-84fa-000c295931fb';
    /**
     * 通用等级
     */
    default_1.DICT_COMMON_LEVEL = '1559c0e6-d04e-11e9-84fa-000c295931fb';
    return default_1;
}());
exports.default = default_1;
