"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
var d3 = require("d3");
var _ = require("lodash");
var events = {};
if (_.has(window, '_events')) {
    events = window['_events'];
}
else {
    window['_events'] = {};
    events = window['_events'];
}
var default_1 = /** @class */ (function () {
    function default_1() {
    }
    /**
     * 呼叫下载，分两种情况，传参根据第一个参数确定
     *
     * 有心中时
     * 参数1 : resp 带workId的下载响应体（object）
     * 参数2 : process 进度地址
     * 参数3 : download 下载地址
     *
     *
     * 无心跳时：
     *
     * 参数1 ：resp 下载地址 (string)
     * 参数2 : process 文件名
     *
    */
    default_1.callDownload = function (resp, proc, download) {
        if (proc === void 0) { proc = null; }
        if (download === void 0) { download = null; }
        if (_.has(events, '_download')) {
            events['_download'].call(null, resp, proc, download);
        }
    };
    default_1.on = function (type, fn) {
        var evt = type.toLowerCase();
        if (_.has(events, evt)) {
            return;
        }
        events[evt] = d3.dispatch(evt);
        events[evt].on(evt, fn);
    };
    default_1.call = function (type) {
        var _a;
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        var evt = type.toLowerCase();
        if (_.has(events, evt)) {
            (_a = events[evt]).call.apply(_a, __spreadArray([evt, null], __read(args), false));
        }
    };
    return default_1;
}());
exports.default = default_1;
