"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.highLight = void 0;
var React = require("react");
var _ = require("lodash");
var CACHE = {};
var getCache = function (keyword) {
    if (CACHE[keyword]) {
        return CACHE[keyword];
    }
    var word = _.trim(keyword);
    if (word.length == 0) {
        return function (v) { return v; };
    }
    var key = word.toLowerCase();
    var keyLen = key.length;
    var FN = function (sentence) {
        var str = _.trim(sentence);
        if (str.length == 0) {
            return '';
        }
        var strLen = str.length;
        var fixed = new Array(strLen);
        var searchStr = str.toLowerCase();
        var hasFix = false;
        var idx = searchStr.indexOf(key);
        while (idx >= 0) {
            hasFix = true;
            for (var i = 0; i < keyLen; i++) {
                fixed[idx + i] = 1;
            }
            idx = searchStr.indexOf(key, idx + keyLen);
        }
        if (!hasFix) {
            return str;
        }
        var matched = [];
        var tagging = false;
        var start = 0;
        for (var i = 0; i < strLen; i++) {
            if (fixed[i]) {
                if (!tagging) {
                    tagging = true;
                    start = i;
                }
                if (i == (strLen - 1)) {
                    tagging = false;
                    matched.push(start);
                }
            }
            else {
                if (tagging) {
                    tagging = false;
                    matched.push(start);
                }
            }
        }
        var domList = [];
        var cur = 0;
        for (var i = 0, _i = matched.length; i < _i; i++) {
            var pos = matched[i];
            domList.push(str.substring(cur, pos));
            // domList.push(str.substring(pos, pos + keyLen))
            domList.push(React.createElement("span", { className: 'highlight' }, str.substring(pos, pos + keyLen)));
            cur = pos + keyLen;
        }
        if (cur < str.length) {
            domList.push(str.substring(cur));
        }
        return domList;
    };
    CACHE[keyword] = FN;
    window.setTimeout(function () { return _.unset(CACHE, keyword); }, 5000);
    return FN;
};
var highLight = function (sentence, keyword) { return getCache(keyword)(sentence); };
exports.highLight = highLight;
