/**
 * 正则表达式
 */
export default abstract class {
    /**
     * 验证单个IP不带端口号
     */
    static singleIp: RegExp;
    /**
     * 验证单个IP带端口号
     */
    static singleIpAndPort: RegExp;
    /**
     * 验证多个IP
     * ip之间以,隔开
     */
    static mutiIp: RegExp;
    /**
     * 验证单个IPv6地址
     */
    static singleIpv6: RegExp;
    /**
     * 验证MAC地址
     */
    static macAddr: RegExp;
    /**
     * 验证身份证号码
     */
    static idCard: RegExp;
    /**
     * 验证网址
     * 网址需要以http|ftp|https开头
     */
    static webSite: RegExp;
    /**
     * 验证是否在经度范围内
     * -180~180
     */
    static lng: RegExp;
    /**
     *  判断是否在纬度范围内
     * -90~90
     */
    static lat: RegExp;
    /**
     * 验证是否为中文、英文字母、数字和_
     */
    static normalWords: RegExp;
    /**
     * 验证是否为英文字母、数字和_
     */
    static enNumWords: RegExp;
    /**
     * 验证端口格式
     */
    static port: RegExp;
    /**
     * 手机号码
    */
    static phone: RegExp;
    /**
     * 固定电话号码
     */
    static mobile: RegExp;
    /**
     * 邮箱
    */
    static email: RegExp;
    /**
     * 邮箱
    */
    static illegalChar: RegExp;
}
