"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
/**
 * 说明 VAP 微服前端模块注册，仅限3.4.2后的vap版本使用，统一升级，所有模块必须更新
 */
var getUrlMap = function () {
    if (_.has(window, '__storeModuleUrl')) {
        return window['__storeModuleUrl'];
    }
    else {
        window['__storeModuleUrl'] = new Map();
        return getUrlMap();
    }
};
var getServiceMap = function () {
    if (_.has(window, '__storeModule')) {
        return window['__storeModule'];
    }
    else {
        window['__storeModule'] = new Map();
        return getServiceMap();
    }
};
var Manager = /** @class */ (function () {
    function Manager(all_groups) {
        this.ALL_GROUPS = null;
        this.ALL_GROUPS = all_groups;
    }
    Manager.prototype.getServiceIdByUrl = function (pathname) {
        var e_1, _a;
        var ALL_URLS = getUrlMap();
        var service_id = ALL_URLS.get(pathname);
        if (service_id) {
            return service_id;
        }
        for (var i = 0; i < this.ALL_GROUPS.length; i++) {
            var group = this.ALL_GROUPS[i];
            if (group.indexOf(pathname) >= 0) {
                var service_id = '';
                try {
                    for (var group_1 = (e_1 = void 0, __values(group)), group_1_1 = group_1.next(); !group_1_1.done; group_1_1 = group_1.next()) {
                        var path = group_1_1.value;
                        if (ALL_URLS.has(path)) {
                            service_id = ALL_URLS.get(path);
                            break;
                        }
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (group_1_1 && !group_1_1.done && (_a = group_1.return)) _a.call(group_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
                if (service_id) {
                    group.map(function (path) {
                        ALL_URLS.set(path, service_id);
                    });
                    break;
                }
            }
        }
        return ALL_URLS.get(pathname);
    };
    Manager.prototype.getModelsByServiceId = function (service_id) {
        var modelsMap = getServiceMap();
        return modelsMap.get(service_id) || [];
    };
    return Manager;
}());
var VapRegister = /** @class */ (function () {
    function VapRegister(service_id) {
        this.service_id = '';
        this.pathname = '';
        var ALL_URLS = getUrlMap();
        this.service_id = service_id;
        if (service_id == '_GLOBAL') {
            this.pathname = '_';
        }
        else {
            this.pathname = window.location.pathname;
        }
        ALL_URLS.set(this.pathname, service_id);
    }
    VapRegister.getManager = function (all_groups) {
        return new Manager(all_groups);
    };
    VapRegister.prototype.toArray = function (model) {
        var e_2, _a;
        if (model.namespace) {
            return [model];
        }
        var keys = _.keys(model);
        var models = [];
        try {
            for (var keys_1 = __values(keys), keys_1_1 = keys_1.next(); !keys_1_1.done; keys_1_1 = keys_1.next()) {
                var key = keys_1_1.value;
                if (_.isObject(model[key]) && model[key].namespace) {
                    models.push(model[key]);
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (keys_1_1 && !keys_1_1.done && (_a = keys_1.return)) _a.call(keys_1);
            }
            finally { if (e_2) throw e_2.error; }
        }
        return models;
    };
    VapRegister.prototype.models = function () {
        var _this = this;
        var models = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            models[_i] = arguments[_i];
        }
        var moudlesMap = getServiceMap();
        var moudles = moudlesMap.get(this.service_id) || [];
        // @ts-ignore
        var ALL_MODELS = window['app']._models;
        var modSet = new Set();
        ALL_MODELS.map(function (item) { return modSet.add(item.namespace); });
        models.map(function (item) { return _this.toArray(item).map(function (model) {
            // 同一个 modelname / service_id 只能注册一次
            if (_.findIndex(moudles, { namespace: model.namespace }) < 0) {
                // 第一次加载前，卸载掉冲突
                if (modSet.has(model.namespace)) {
                    // console.log('卸载', model.namespace)
                    window.app.unmodel(model.namespace);
                }
                moudles.push(model);
                window.app.model(model);
            }
            else {
                // console.log('已经注册', model.namespace)
            }
        }); });
        moudlesMap.set(this.service_id, moudles);
    };
    VapRegister.prototype.views = function () {
        var components = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            components[_i] = arguments[_i];
        }
        var filters = components.map(function (item) {
            var component = null;
            component = item.component;
            if (typeof item.component != 'function') {
                if (item.component.default && typeof item.component.default == 'function') {
                    component = item.component.default;
                }
            }
            return __assign(__assign({}, item), { component: component });
        });
        window.registerComponents.apply(window, __spreadArray([], __read(filters), false));
    };
    VapRegister.prototype.nodes = function () {
        var nodes = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            nodes[_i] = arguments[_i];
        }
        window.registerNodes.apply(window, __spreadArray([], __read(nodes), false));
    };
    VapRegister.prototype.lazyLoad = function (resolveView, resolveModels) {
        var self = this;
        return loadComponent(function () {
            var component = resolveView();
            var models = [];
            if (typeof resolveModels === 'function') {
                var modelFn = resolveModels();
                if (_.isArray(modelFn)) {
                    modelFn.map(function (m) { return models.push(toPromise(m)); });
                }
                else {
                    models.push(toPromise(modelFn));
                }
            }
            // console.log(models)
            return new Promise(function (resolve) {
                Promise.all(__spreadArray(__spreadArray([], __read(models), false), [component], false)).then(function (ret) {
                    if (!models || !models.length) {
                        // console.log('载入视图（无需装配模型）')
                        return resolve(ret[0]);
                    }
                    else {
                        var len = models.length;
                        ret.slice(0, len).forEach(function (m) {
                            _.keys(m).map(function (key) {
                                // console.log(m)
                                if (_.has(m[key], 'namespace')) {
                                    // console.log('注册模型' + m[key].namespace)
                                    self.models(m[key]);
                                }
                                else {
                                    // console.error()
                                }
                            });
                        });
                        // console.log('模型装配完成，载入视图')
                        resolve(ret[len]);
                    }
                });
            });
        });
    };
    return VapRegister;
}());
exports.default = VapRegister;
var React = require("react");
var antd_1 = require("antd");
function toPromise(obj) {
    if (!!obj && (typeof obj === 'object' || typeof obj === 'function') && typeof obj.then === 'function') {
        return obj;
    }
    return new Promise(function (resolve) { return resolve({ default: obj }); });
}
function loadComponent(resolve) {
    return /** @class */ (function (_super) {
        __extends(DynamicComponent, _super);
        function DynamicComponent(args) {
            var _this = _super.call(this, args) || this;
            _this.mounted = false;
            _this.state = {
                AsyncComponent: null,
            };
            _this.load();
            return _this;
        }
        DynamicComponent.prototype.componentDidMount = function () {
            this.mounted = true;
        };
        DynamicComponent.prototype.componentWillUnmount = function () {
            this.mounted = false;
        };
        DynamicComponent.prototype.load = function () {
            var _this = this;
            resolve().then(function (m) {
                var AsyncComponent = m.default || m;
                if (_this.mounted) {
                    _this.setState({ AsyncComponent: AsyncComponent });
                }
                else {
                    _this.state.AsyncComponent = AsyncComponent; // eslint-disable-line
                }
            });
        };
        DynamicComponent.prototype.render = function () {
            var AsyncComponent = this.state.AsyncComponent;
            if (AsyncComponent)
                return React.createElement(AsyncComponent, __assign({}, this.props));
            return React.createElement(antd_1.Spin, { style: { margin: '100px auto', width: '100%' } });
        };
        return DynamicComponent;
    }(React.Component));
}
