"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Widget = void 0;
var React = require("react");
var Service_1 = require("../_common/Service");
var WidgetUtil_1 = require("./WidgetUtil");
var Widget = /** @class */ (function (_super) {
    __extends(Widget, _super);
    function Widget() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * 组件依赖的脚本,可以为零个或多个，通常不建议小组件再引入脚本
        */
        _this.REQUIRE_JS = [];
        /**
         * 组件依赖的服务,可以为零个或多个，通常不建议小组件再引入样式
        */
        _this.REQUIRE_CSS = [];
        /**
         * 组件依赖的服务,可以为零个或多个，如果多个时，每个服务都启动的状态下才出组件
        */
        _this.REQUIRE_SERVICE = [];
        return _this;
    }
    Widget.prototype.componentDidMount = function () {
        if (this.REQUIRE_CSS.length) {
            this.REQUIRE_CSS.map(function (item) {
                WidgetUtil_1.WidgetManager.loadCss(item);
            });
        }
    };
    Widget.prototype.show = function () {
        return React.createElement("div", null, "\u8BF7\u5F00\u53D1\u6B64\u7EC4\u4EF6");
    };
    ;
    Widget.prototype.render = function () {
        var e_1, _a;
        if (this.REQUIRE_SERVICE.length) {
            try {
                for (var _b = __values(this.REQUIRE_SERVICE), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var serviceId = _c.value;
                    if (!Service_1.default.hasService(serviceId)) {
                        return [];
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
        return this.show();
    };
    ;
    return Widget;
}(React.PureComponent));
exports.Widget = Widget;
