"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WidgetUtil = exports.WidgetManager = void 0;
var _ = require("lodash");
var React = require("react");
var Ajax_1 = require("../utils/Ajax");
var Events_1 = require("../utils/Events");
var getRegisteredWidgets = function () {
    if (!_.has(window, '__VAP_WIDGETS')) {
        window['__VAP_WIDGETS'] = new Map();
    }
    return window['__VAP_WIDGETS'];
};
var getWidgetStatus = function () {
    if (!_.has(window, '__VAP_WIDGETS_STATUS')) {
        window['__VAP_WIDGETS_STATUS'] = new Map();
    }
    return window['__VAP_WIDGETS_STATUS'];
};
var getWidgetCss = function () {
    if (!_.has(window, '__VAP_WIDGETS_CSS')) {
        window['__VAP_WIDGETS_CSS'] = new Set();
    }
    return window['__VAP_WIDGETS_CSS'];
};
var _WidgetManager = /** @class */ (function () {
    function _WidgetManager() {
        this.WIDGETS = [];
        try {
            var resp = Ajax_1.default.GETASYNC('/api-common/role/widgets');
            if (resp.code == 0 && _.isArray(resp.data)) {
                this.WIDGETS = resp.data;
            }
        }
        catch (e) {
            console.error(e);
        }
    }
    _WidgetManager.prototype.loadCss = function (css) {
        var LoadCSS = getWidgetCss();
        if (LoadCSS.has(css)) {
            return;
        }
        ;
        LoadCSS.add(css);
        var link = document.createElement('link');
        link.setAttribute('href', css);
        link.setAttribute('rel', 'stylesheet');
        link.setAttribute('type', 'text/css');
        document.body.append(link);
    };
    _WidgetManager.prototype.getByPath = function (path) {
        var Widget = getRegisteredWidgets();
        if (Widget.has(path)) {
            return Widget.get(path);
        }
        return null;
    };
    _WidgetManager.prototype.loadByPath = function (path) {
        var MAX_WAIT = 5000;
        return new Promise(function (resolve, reject) {
            // 测试组件
            var test = function () {
                var Loaded = getWidgetStatus();
                var loaded = Loaded.get(path);
                if (_.isBoolean(loaded)) {
                    resolve(loaded);
                    return;
                }
                window.setTimeout(function () { return test(); }, 66);
            };
            var Loaded = getWidgetStatus();
            if (Loaded.has(path)) {
                var content = Loaded.get(path);
                if (_.isBoolean(content)) {
                    resolve(content);
                }
                else {
                    test();
                }
                return;
            }
            Loaded.set(path, null);
            var pid = window.setTimeout(function () {
                var Loaded = getWidgetStatus();
                Loaded.set(path, false);
                resolve(false);
                return;
            }, MAX_WAIT);
            var EVENT_NAME = _.replace(path, /[\/\.\-]/gi, '');
            Events_1.default.on(EVENT_NAME, function (clazz) {
                window.clearTimeout(pid);
                var Widget = getRegisteredWidgets();
                var Loaded = getWidgetStatus();
                Widget.set(path, clazz);
                Loaded.set(path, true);
                resolve(true);
                return;
            });
            var script = document.createElement('script');
            script.src = path;
            document.body.append(script);
        });
    };
    return _WidgetManager;
}());
exports.WidgetManager = new _WidgetManager();
var _WidgetUtil = /** @class */ (function () {
    function _WidgetUtil() {
        /**
         * 注册小组件
        */
        this.registerWidget = function (clazz) {
            var currentScript = document.currentScript || (function () {
                var scripts = document.getElementsByTagName('script');
                return scripts[scripts.length - 1];
            })();
            var path = currentScript.getAttribute('src');
            var EVENT_NAME = _.replace(path, /[\/\.\-]/gi, '');
            Events_1.default.call(EVENT_NAME, clazz);
        };
        /**
         * 显示小组件，
         * 说明 showWidget 没有权限控制，如果需要进行权限验证，使用 layoutWidget
         * @path 为小组件的JS文件路径绝对地址 ，必传
         * @props 为传给小组件的参数
        */
        this.showWidget = function (path, props) {
            var widget = _.find(exports.WidgetManager.WIDGETS, { path: path }) || {};
            return React.createElement(WidgetWraper, __assign({ path: path, _widget: widget }, props));
        };
        /**
         * 自定义布局的小组件
         * @path 为小组件的JS文件路径绝对地址 ，也支持小组件的id
         * @fn 小组件的布局回调方法，说明，小组件为空时，则回调的参数为null，需要自行判断
         * @props 为传给小组件的参数
        */
        this.layoutWidget = function (path, fn, props) {
            var widget = _.find(exports.WidgetManager.WIDGETS, function (item) { return item.path == path || item.id == path; });
            var WidgetContent = null;
            if (widget) {
                WidgetContent = React.createElement(WidgetWraper, __assign({ path: widget.path, _widget: widget }, props));
            }
            return fn(WidgetContent);
        };
        /**
         * 获取当前用户可用的所有小组件
        */
        this.getAll = function () {
            return exports.WidgetManager.WIDGETS;
        };
    }
    return _WidgetUtil;
}());
exports.WidgetUtil = new _WidgetUtil();
var WidgetWraper = /** @class */ (function (_super) {
    __extends(WidgetWraper, _super);
    function WidgetWraper() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            hasRole: true,
            exists: false,
            loading: true,
            widget: null,
        };
        return _this;
    }
    WidgetWraper.prototype.componentDidMount = function () {
        return __awaiter(this, void 0, void 0, function () {
            var result, widget;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, exports.WidgetManager.loadByPath(this.props.path)];
                    case 1:
                        result = _a.sent();
                        if (result) {
                            widget = exports.WidgetManager.getByPath(this.props.path);
                            if (widget) {
                                this.setState({ loading: false, exists: true, widget: React.createElement(widget, this.props) });
                            }
                            else {
                                this.setState({ loading: false, exists: false, });
                            }
                        }
                        else {
                            this.setState({ loading: false, exists: false, });
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    WidgetWraper.prototype.render = function () {
        var _a = this.state, exists = _a.exists, hasRole = _a.hasRole, loading = _a.loading, widget = _a.widget;
        if (loading) {
            return React.createElement("span", null);
            // return <span><Spin tip="正在载入" style={{ margin: '48px auto', display: 'block' }} /></span>
        }
        if (!hasRole) {
            return React.createElement("span", null, "\u6682\u65E0\u6B64\u7EC4\u4EF6\u6743\u9650");
        }
        if (!exists) {
            console.error('小组件加载失败', this.props);
            return React.createElement("span", null, "\u5C0F\u7EC4\u4EF6\u52A0\u8F7D\u5931\u8D25");
        }
        return widget;
    };
    return WidgetWraper;
}(React.PureComponent));
